
# line 2 "/usr/local/src/postgres/src/backend/parser/gram.y"
#define YYDEBUG 1
/**********************************************************************

  $Header: /data/01/postgres/src/backend/parser/RCS/gram.y,v 4.22 1993/06/15 23:32:22 aoki Exp $

  POSTGRES YACC rules/actions
  
  Conventions used in coding this YACC file:

  CAPITALS are used to represent terminal symbols.
  non-capitals are used to represent non-terminals.

 **********************************************************************/

#include <strings.h>
#include <ctype.h>

#include "tmp/c.h"
#include "parser/catalog_utils.h"
#include "catalog/catname.h"
#include "catalog/pg_log.h"
#include "catalog/pg_magic.h"
#include "catalog/pg_time.h"
#include "catalog/pg_variable.h"
#include "access/heapam.h"
#include "utils/log.h"
#include "utils/palloc.h"
#include "nodes/pg_lisp.h"
/* XXX ORDER DEPENDENCY */
#include "parser/parse_query.h"
#include "nodes/primnodes.h"
#include "nodes/primnodes.a.h"
#include "rules/params.h"
#include "utils/lsyscache.h"
#include "tmp/acl.h"
extern LispValue new_filestr();
extern LispValue parser_typecast();
extern LispValue make_targetlist_expr();
extern List MakeList();
extern List FlattenRelationList();
extern List ParseAgg();
extern LispValue make_array_ref();

#define ELEMENT 	yyval = nappend1( LispNil , yypvt[-0] )

#define INC_LIST 	yyval = nappend1( yypvt[-2] , yypvt[-0] ) /* $1,$3 */

#define NULLTREE	yyval = LispNil ; 
#define LAST(lv)        lispCons ( lv , LispNil )

#define INC_NUM_LEVELS(x)	{ if (NumLevels < x ) NumLevels = x; }
#define KW(keyword)		lispAtom(CppAsString(keyword))

#define ADD_TO_RT(rt_entry)     p_rtable = nappend1(p_rtable,rt_entry) 

#define YYSTYPE LispValue
extern YYSTYPE parsetree;

LispValue NewOrCurrentIsReally = (LispValue)NULL;
bool ResdomNoIsAttrNo = false;
extern YYSTYPE parser_ppreserve();

static YYSTYPE temp;

int NumLevels = 0;

YYSTYPE yylval;

YYSTYPE p_target,
        p_qual,
        p_root,
        p_priority,
        p_ruleinfo;
YYSTYPE	       p_rtable,
               p_target_resnos;

static int p_numlevels,p_last_resno;
Relation parser_current_rel = NULL;
static bool QueryIsRule = false;
static int parser_current_query;

bool Input_is_string = false;
bool Input_is_integer = false;
bool Typecast_ok = true;
# define ABORT_TRANS 257
# define ADD_ATTR 258
# define APPEND 259
# define ATTACH_AS 260
# define BEGIN_TRANS 261
# define CHANGE 262
# define CLOSE 263
# define CLUSTER 264
# define COPY 265
# define CREATE 266
# define DEFINE 267
# define DELETE 268
# define DESTROY 269
# define END_TRANS 270
# define EXECUTE 271
# define EXTEND 272
# define FETCH 273
# define MERGE 274
# define MOVE 275
# define PURGE 276
# define REMOVE 277
# define RENAME 278
# define REPLACE 279
# define RETRIEVE 280
# define ACL 281
# define ALL 282
# define ALWAYS 283
# define AFTER 284
# define AND 285
# define ARCHIVE 286
# define ARCH_STORE 287
# define ARG 288
# define ASCENDING 289
# define BACKWARD 290
# define BEFORE 291
# define BINARY 292
# define BY 293
# define DEMAND 294
# define DESCENDING 295
# define EMPTY 296
# define FORWARD 297
# define FROM 298
# define GROUP 299
# define HEAVY 300
# define INTERSECT 301
# define INTO 302
# define IN 303
# define INDEX 304
# define INDEXABLE 305
# define INHERITS 306
# define INPUTPROC 307
# define IS 308
# define KEY 309
# define LEFTOUTER 310
# define LIGHT 311
# define STORE 312
# define NEVER 313
# define NEWVERSION 314
# define NONE 315
# define NONULLS 316
# define NOT 317
# define PNULL 318
# define ON 319
# define ONCE 320
# define OR 321
# define OUTPUTPROC 322
# define PORTAL 323
# define PRIORITY 324
# define QUEL 325
# define RIGHTOUTER 326
# define RULE 327
# define SCONST 328
# define SETOF 329
# define SORT 330
# define TO 331
# define TRANSACTION 332
# define UNION 333
# define UNIQUE 334
# define USING 335
# define WHERE 336
# define WITH 337
# define FUNCTION 338
# define OPERATOR 339
# define P_TYPE 340
# define USER 341
# define IDENT 342
# define ICONST 343
# define Op 344
# define CCONST 345
# define FCONST 346
# define INHERITANCE 347
# define VERSION 348
# define CURRENT 349
# define NEW 350
# define THEN 351
# define DO 352
# define INSTEAD 353
# define VIEW 354
# define REWRITE 355
# define P_TUPLE 356
# define TYPECAST 357
# define P_FUNCTION 358
# define C_FUNCTION 359
# define C_FN 360
# define POSTQUEL 361
# define RELATION 362
# define RETURNS 363
# define INTOTEMP 364
# define LOAD 365
# define CREATEDB 366
# define DESTROYDB 367
# define STDIN 368
# define STDOUT 369
# define VACUUM 370
# define PARALLEL 371
# define AGGREGATE 372
# define NOTIFY 373
# define LISTEN 374
# define IPORTAL 375
# define ISNULL 376
# define NOTNULL 377
# define UMINUS 378
# define REDUCE 379
# define PARAM 380
# define AS 381
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern short yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#ifndef YYSTYPE
#define YYSTYPE int
#endif
YYSTYPE yylval, yyval;
# define YYERRCODE 256

# line 2226 "/usr/local/src/postgres/src/backend/parser/gram.y"

parser_init(typev, nargs)
	ObjectId *typev;
	int nargs;
{
	NumLevels = 0;
	p_target = LispNil;
	p_qual = LispNil;
	p_root = LispNil;
	p_priority = lispInteger(0);
	p_ruleinfo = LispNil;
	p_rtable = LispNil;
	p_last_resno = 1;
	p_numlevels = 0;
	p_target_resnos = LispNil;
	ResdomNoIsAttrNo = false;
	QueryIsRule = false;
	Input_is_string = false;
	Input_is_integer = false;
	Typecast_ok = true;

	param_type_init(typev, nargs);
}


LispValue
make_targetlist_expr ( name , expr, arrayRef )
     LispValue name;
     LispValue expr;
     LispValue arrayRef;
{
    extern bool ResdomNoIsAttrNo;
    extern Relation parser_current_rel;
    int type_id,type_len, attrtype, attrlen;
    int resdomno;
    Relation rd;

    if(ResdomNoIsAttrNo && (expr == LispNil) && !Typecast_ok){
       /* expr is NULL, and the query is append or replace */
       /* append, replace work only on one relation,
          so multiple occurence of same resdomno is bogus */
       rd = parser_current_rel;
       Assert(rd != NULL);
       resdomno = varattno(rd,CString(name));
       attrtype = att_typeid(rd,resdomno);
       attrlen = tlen(get_id_type(attrtype));
       expr = lispCons( lispInteger(attrtype), (LispValue)
                MakeConst((ObjectId) attrtype, (Size) attrlen, (Datum) LispNil, (bool)1, (bool) 0 /* ignored */));
       Input_is_string = false;
       Input_is_integer = false;
       Typecast_ok = true;
       if( lispAssoc( lispInteger(resdomno),p_target_resnos)
          != -1 ) {
           elog(WARN,"two or more occurence of same attr");
       } else {
           p_target_resnos = lispCons( lispInteger(resdomno),
                                     p_target_resnos);
       }
       return  ( lispCons ((LispValue)MakeResdom ((AttributeNumber)resdomno,
				       (ObjectId) attrtype,
				       ISCOMPLEX(attrtype),
				       (Size)attrlen ,
				       (Name)CString(name),
				       (Index) 0 ,
				       (OperatorTupleForm) 0 , 0 ) ,
                             lispCons((LispValue)CDR(expr),LispNil)) );
     }
 
    type_id = CInteger(CAR(expr));
    type_len = tlen(get_id_type(type_id));
    if (ResdomNoIsAttrNo) { /* append or replace query */
	/* append, replace work only on one relation,
	   so multiple occurence of same resdomno is bogus */
	rd = parser_current_rel;
	Assert(rd != NULL);
	resdomno = varattno(rd,CString(name));
	attrtype = att_typeid(rd,resdomno);
	if ((arrayRef != LispNil) && (CAR(arrayRef) == LispNil))
		attrtype = GetArrayElementType(attrtype);
	attrlen = tlen(get_id_type(attrtype)); 
	if(Input_is_string && Typecast_ok){
              Datum val;
              if (CInteger(CAR(expr)) == typeid(type("unknown"))){
                val = textout((struct varlena *)get_constvalue((Const)CDR(expr)));
              }else{
                val = get_constvalue((Const)CDR(expr));
              }
              CDR(expr) = (LispValue) MakeConst(attrtype, attrlen,
	  (Datum)fmgr(typeid_get_retinfunc(attrtype),val,get_typelem(attrtype)),
                false, true /*??? Maybe correct-- 80% chance */);
	} else if((Typecast_ok) && (attrtype != type_id)){
              CDR(expr) = (LispValue) 
			parser_typecast2 ( expr, get_id_type((long)attrtype));
	} else 
	     if (attrtype != type_id)
		elog(WARN, "unequal type in tlist : %s \n", CString(name));
	Input_is_string = false;
	Input_is_integer = false;
        Typecast_ok = true;

	if( lispAssoc( lispInteger(resdomno),p_target_resnos) != -1 ) {
	    elog(WARN,"two or more occurence of same attr");
	} else {
	    p_target_resnos = lispCons( lispInteger(resdomno),
				       p_target_resnos);
	}
	if (arrayRef != LispNil) {
		LispValue target_expr;
		target_expr = HandleNestedDots (lispCons(
				lispString(RelationGetRelationName(rd)), 
				lispCons(name, LispNil)));
		expr = (LispValue) make_array_set(target_expr, CDR(arrayRef), CAR(arrayRef), expr);	
		attrtype = att_typeid(rd,resdomno);
		attrlen = tlen(get_id_type(attrtype)); 
	}
    } else {
	resdomno = p_last_resno++;
	attrtype = type_id;
	attrlen = type_len;
    }
    return  ( lispCons ((LispValue)MakeResdom ((AttributeNumber)resdomno,
				    (ObjectId)  attrtype,
				    ISCOMPLEX(attrtype),
				    (Size)  attrlen , 
				    (Name)  CString(name), (Index)0 ,
				    (OperatorTupleForm)0 , 0 ) ,
			      lispCons(CDR(expr),LispNil)) );
    
}
short yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
-1, 2,
	0, 3,
	-2, 1,
-1, 36,
	327, 163,
	-2, 222,
-1, 133,
	331, 332,
	-2, 335,
-1, 314,
	40, 340,
	123, 340,
	-2, 332,
-1, 335,
	46, 332,
	-2, 313,
-1, 370,
	344, 0,
	-2, 302,
-1, 383,
	344, 0,
	-2, 301,
-1, 432,
	60, 0,
	62, 0,
	-2, 292,
-1, 433,
	60, 0,
	62, 0,
	-2, 293,
-1, 435,
	344, 0,
	-2, 300,
-1, 535,
	40, 340,
	-2, 335,
-1, 589,
	46, 332,
	-2, 255,
	};
# define YYNPROD 374
# define YYLAST 1146
short yyact[]={

 314,  27, 588, 312, 547, 289, 486, 308, 558, 105,
  73, 487, 106, 531, 183, 557, 442, 477, 333, 441,
  93, 216, 247, 230, 305, 377, 263,  97,  98, 375,
 278, 297, 220,  84, 418, 171, 458, 332, 309,  92,
  96, 240,  96, 108, 170, 104,  96, 220,  96,  96,
 607, 133, 103, 604, 611, 462, 110, 187, 315, 116,
 186, 495, 140, 140,  94, 408, 101, 131, 155,  96,
 115, 355, 118, 119,  71, 132, 153, 156, 283, 156,
 156,  93, 108,  93, 219,  78,  88,  89,  97,  98,
 128,  88,  89, 147, 184, 366, 363,  93, 364, 219,
 365,  81,  86,  85,  97,  98, 127,  86,  85,  87,
 181, 356, 357, 367,  87, 368, 352,  96, 353,  79,
 488, 108, 108, 522, 129,  93, 488, 453,  74, 417,
 241, 578, 195, 366, 363, 327, 364, 296, 365, 290,
 419, 115,  93, 187, 414, 196, 186, 136, 114, 481,
 185, 367, 369, 368, 135, 187, 185, 187, 186, 293,
 186, 134, 536, 325, 276, 215, 181, 221, 222, 108,
 223,  74, 545, 108, 181,  96, 286, 268, 153,  96,
 108, 138, 233,  93, 480, 266,  67,  93, 468,  96,
  96, 213, 292, 168, 285,  69, 248, 173,  65, 235,
 176, 178, 538, 238, 248, 248,  66,  64, 360, 349,
 344, 251, 425, 244, 115,  96,  96, 569, 269, 474,
 108, 108,  67, 255, 256, 110, 153, 108, 570, 156,
 331,  69, 571, 243,  65, 185, 214, 217, 189, 260,
 261, 295,  66,  64, 108, 573, 113, 100, 201, 366,
 363, 200, 364, 112, 365, 200, 507, 281, 108, 108,
 108, 566, 201, 504,  96, 193,  90, 367, 369, 368,
 321, 335, 503, 198,  96,  96, 269,  96, 337, 218,
 322, 151, 242, 502, 501, 142,  96, 594, 328, 249,
 385, 152, 180, 189, 614, 334,  96, 284, 338, 339,
  68, 341, 336, 350, 527,  93, 514, 505, 460, 447,
 348, 187, 319, 376, 190, 187, 459, 427, 343, 199,
 362, 288, 248,   3, 139,   1, 395, 185, 585, 576,
 269,  96, 269, 367, 366, 368,  68, 567, 245, 365,
 539, 389, 394, 454, 347, 226, 584, 156, 413,  80,
 384, 416, 367, 489, 368, 115,  93, 482, 111, 387,
  83,  93, 415, 192, 144, 403, 404, 154,  97,  98,
 306, 402, 189, 523, 597, 601, 373, 179, 108, 556,
 574, 525, 409, 575, 401, 395, 185, 141, 395, 423,
 179, 421, 392, 108, 109, 150, 149, 335,  82, 130,
 351, 329, 335, 395, 337, 117, 318, 446, 439, 337,
 124, 108, 374, 107, 524, 284, 188, 401, 464, 466,
 451, 334, 450, 463, 471, 411, 452, 395, 336, 371,
 372, 248, 225, 336, 449, 370, 469, 378, 379, 380,
 381, 382, 383, 478, 125, 386, 166, 167, 122, 457,
 479, 511, 169, 340, 512, 232, 335, 335, 229, 237,
 185, 555, 485, 337, 337, 401, 234, 371, 372, 540,
 498, 393, 165, 254, 108, 483, 108, 250, 484, 398,
 334, 334, 391, 395, 513, 510, 509, 336, 336, 330,
 395, 202, 203, 493, 494, 390, 264, 497, 496, 517,
 535, 428, 429, 430, 431, 432, 433, 434, 435, 399,
 515, 436, 437, 395, 438, 397, 533, 277, 253, 294,
 562, 521, 548, 445,  96, 499, 475, 519, 520, 478,
 541, 337, 526, 560, 560, 400, 456,  96, 401, 231,
 324, 455, 426, 107, 559, 559, 410, 396, 551, 561,
 239, 370, 313, 345, 385, 550, 346, 395, 270, 259,
 560, 564, 579, 108, 554, 258, 552, 553, 581, 257,
 580, 586, 572, 533, 589, 582, 548, 593,  95, 224,
 591, 337, 225, 371, 372, 395, 273, 274, 275, 600,
 271, 272, 491, 228, 177, 602, 603, 279, 551,  75,
 490, 599, 589, 549, 605, 590, 444, 609, 610, 337,
 298, 577, 342, 613, 317, 388, 246, 616, 191, 516,
 267, 596, 518, 265, 592, 598, 551, 546, 107, 323,
 323, 532, 530, 590, 529, 587,  57,  35,  67,   6,
  58,  37,  38,  39,  40,  41,  36,  69,  42,  59,
  65,  43,  44,  45,  46,  48,  49,  50,  66,  64,
  57,  35,  67,   6,  58,  37,  38,  39,  40,  41,
  36,  69,  42,  59,  65,  43,  44,  45,  46,  48,
  49,  50,  66,  64, 544, 543, 326, 303, 443, 262,
 143, 405, 299, 145, 407, 148, 303, 406, 146,  56,
  54, 299,  53,  52,  51, 300, 301, 137, 160, 158,
  55, 159, 606, 161, 300, 301, 595, 583, 563, 500,
 366, 363, 615, 364, 612, 365, 162, 164, 163, 608,
 467, 420, 287, 205, 320, 121, 303, 126, 367, 369,
 368, 299, 123, 120,  60,  61,  62, 197, 279,  63,
   4, 528,  68,  47, 300, 301, 465,  77, 252, 194,
 182, 282, 412, 448, 461, 280, 227,  76,  60,  61,
  62, 302, 476,  63, 359, 568,  68,  47, 508, 473,
 302, 107, 366, 363, 361, 364, 102, 365, 440, 366,
 363, 565, 364, 537, 365, 506, 472, 424, 358, 236,
 367, 369, 368, 175, 470, 422, 354, 367, 369, 368,
 366, 363, 291, 364, 174, 365, 208, 206,  99, 207,
 302, 209,  91, 172,  34, 492,  33,  32, 367, 369,
 368,  31,  30, 542, 210, 212, 211,  29,  28,  26,
  25,  24,  23,  22, 107,  21, 107,  20,  19,  18,
  17,  16,  15,  14,  13,  12,  11,  10,   9,   8,
   7,  72,   5,  70,   2,   0,   0,   0,   0,   0,
 534,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0, 107,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0, 373, 307, 316,   0,   0,   0,   0,
   0,   0,   0, 307, 316,  74,   0,   0,   0,   0,
   0,   0,   0,   0,  74,   0,   0,   0,   0,  93,
 187, 304, 311, 310,   0,   0,  97,  98,  93, 187,
 304, 311, 310,   0,   0,  97,  98,   0,  93,   0,
 157,   0,   0, 307, 316,   0,   0,   0,   0,   0,
   0,   0, 370,   0,  74, 373,   0, 315,   0,   0,
   0,   0, 373,   0,   0,   0, 315,   0,  93, 187,
   0, 311, 310,   0,   0,  97,  98,   0,   0,   0,
   0,   0,   0, 373, 371, 372,   0,   0,   0,   0,
   0, 374,   0,   0,   0,   0,   0,   0, 374,   0,
   0,   0,   0,   0,   0,   0, 315,   0,   0,   0,
   0,   0,   0,   0, 370,   0,   0,   0,   0, 374,
   0, 370,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0, 370,   0,   0,   0, 371, 372, 204,   0,
   0,   0,   0, 371, 372,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0, 371, 372 };
short yypact[]={

 379,-1000,-1000,-1000,-269,-1000,-157,-1000,-1000,-1000,
-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,
-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,
-1000,-1000,-1000,-1000,-1000, 559,-253, -15,-259,-261,
 -45,-245,-259, -79, -44,  19, -44,-261,-261,-248,
-261,-1000,-1000,-1000,-1000,-1000,-1000,-171,-178,-185,
-147,-259,-259,-1000,-1000,-1000,-1000,-1000,-261,-1000,
 379, 403,-1000,-1000,-1000,-259, 666, -79, 666, 666,
-134,-259,-1000,-1000,-1000,-312,-1000,-321,-1000,-1000,
-1000,-1000,-1000,-1000,-122,-1000,-1000,-1000,-1000,-116,
-1000, 554,-113,-1000,-1000,-1000, 346,-1000,-1000,-259,
-1000,-188,-1000,-1000, 114, 272,  19,-186,-1000, -36,
-259,-259, 774,-1000,-1000,-1000,-1000,-1000,-1000,-1000,
-136, -67,-166,-1000,-1000,-1000,-1000,-1000,-1000,-1000,
-1000,-1000,-1000, -61,-291, -61, -61,-1000, -61,-1000,
-1000, 538,-1000, 284,-1000, 553,-1000,-1000,-1000,-1000,
-1000,-1000,-1000,-1000,-1000,-259,-358,-1000,-259,-1000,
-1000,-1000,-259,-259,-261,-1000,-1000,-259,-261,-259,
-206,-1000, -70,-1000,-1000,-1000,-1000,-1000,-261,  19,
-1000,-1000,-157, 248, -70,-1000,-286,-1000, -22, -40,
-157,-157,-1000, 529, 525, 519,-1000,-1000,-1000,-1000,
-1000,-1000,-1000,-1000,-261,-261,-276,-259, 518,-259,
-259,-1000,-1000,-1000,-167,-259,-259, -31, 666,-125,
-152, 230,-1000,-1000,-196,-139, 478, 388, -57,-1000,
-1000, 656,-1000,-259,-1000, 169, 362, 219,-1000,-1000,
-1000,-1000,-1000,-1000,-1000,-1000,-1000,-259,-259,-259,
-168,-1000,-199,-261,-1000, 357,-1000, 186,-1000,-1000,
-322,-1000,-1000,-261,-261,-259,-261,-1000,-1000, 227,
-1000, -98, 512,-1000, 283,-261,-1000, -99,-286,-1000,
  56,-257,-1000,-1000,-101,-261, 768, 222,-332, 656,
 656, 656, 656, 656, 656, 304, 514, 656, 313,-1000,
-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000,-157,-1000,
 454, 346, 441, 348, 430,-259, 507,-1000,-1000,-259,
  19,-259, 494,-1000, 325, 222, 222, 313,-1000,-1000,
-1000,-1000,-1000, -28, 506,-1000, 666,-200,-195,-1000,
 347,-1000,-1000,-1000,-195,-1000,-1000,-1000, -94, 502,
-1000,-1000, 226, 656, 656, 656, 656, 656, 656, 656,
 696,-1000,-1000, 656, 656,-1000, 656,-259,-1000, 273,
 273, 273, 747,  53,-259, 647, 207,-259, 216,-1000,
-1000,-1000,-259,-1000,-1000,-1000,-322,-1000, 169,-1000,
 -61,-322,-155, 282,-1000, 501, 496,-206, 225, 215,
  14,-1000,-1000,-1000,-1000,-1000,-1000,-259,-259,-1000,
-131,-286,-1000,-259, -86, 486,-259,-157, 292, 292,
 273, 273,-1000,-1000, 207,  53, 207, 678,  91,-1000,
-1000, 311,-1000,-1000, 434, 768, 311,-1000,-1000, 421,
-211,-1000, 307,-1000, 656,-322,-322,-1000,-1000, -32,
 225, 429,-1000, 346,-1000, 485,-1000,-1000,   4, 214,
-1000,-1000, -30,-259,-1000,-259, 410,-1000,-196, 213,
 222, 656,-259,-1000, 656,-206,-206, 481,-1000,-159,
-1000, 768, 250, 373, 340, 225, 211,-1000,-1000,-259,
-169,-1000,-1000,-1000,-1000,-1000,-110, 279,-1000, 346,
 428,-1000,-259,-1000,-1000,-1000, 740,-1000, 768,-158,
-1000,-259,-1000,-322,-206,-206,-1000, 225, 420, 335,
-1000,-1000,-217,-217, 480,-1000,-261, -26, 276, -83,
-1000,-1000, 222,-1000, -48,-1000, 339,-1000, 268,-205,
-1000, 304,-1000,-1000,-1000,-211,-259,-1000,-1000,-259,
-1000,-1000,-259,-1000, 300,-1000, 267,-157,-1000,-1000,
-1000,-1000,-1000,-322,-1000,-259,-259, 162, 656,-206,
-1000,-1000, 333,-206,-259,-157,-1000, 331,-1000,-196,
-196,-1000,-1000,-1000,-1000, 768,-1000,-1000,-299,-1000,
-1000,-322,-1000,-1000,-303,-1000, -37,-1000,-1000,-1000,
-1000, -73, 201,-1000,-1000, -73,-1000 };
short yypgo[]={

   0, 325, 864, 863, 323, 862, 861, 860, 859, 858,
 857, 856, 855, 854, 853, 852, 851, 850, 849, 848,
 847, 845, 843, 842, 841, 840, 839,   1, 838, 837,
 832, 831, 827, 826, 824, 281,  24, 823,   9, 822,
 292,   5, 818, 814, 812, 806, 805,  34, 804, 803,
 799, 798, 797, 796, 795, 793, 791, 786, 784,  22,
 779, 778,  12, 775,   3, 774, 772,  17,  16, 767,
 367,  68, 766, 765, 398, 360,   0, 764, 762,  14,
 761,  78, 358, 760, 282, 759, 758, 370, 757, 394,
 756, 751,   6,  41, 148, 747, 273, 319, 743, 742,
 737, 349, 735, 734, 280, 733, 732, 731, 730, 729,
 724, 722, 719, 718, 717, 712, 710, 285, 707, 324,
 704, 703, 702, 700, 699, 698,  21, 364, 697,  37,
 695, 177, 694, 279, 693, 691, 690, 689, 686, 685,
 684, 635,   2,  31, 634, 632,  13, 631,  15,   8,
  11, 627,   4, 624, 623, 185, 620, 137, 618, 616,
 615, 612,  36,  38,  30, 291, 611,  29, 610, 606,
  19,   7, 603, 600,  18, 578, 552 };
short yyr1[]={

   0,   3,   1,   1,   2,   2,   4,   4,   4,   4,
   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,
   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,
   4,   4,   4,   4,   4,   4,   5,  37,   8,   9,
  10,  11,  44,  44,  46,  46,  43,  43,  42,  42,
  12,  12,  58,  58,  57,  57,  57,  53,  53,  61,
  54,  54,  63,  63,  63,  55,  55,  56,  56,  52,
  52,  51,  51,  66,  66,  67,  13,  70,  69,  69,
  71,  71,  71,  71,  71,  71,  71,  71,  71,  73,
  73,  73,  77,  78,  78,  78,  78,  78,  72,  81,
  81,  80,  80,  14,  16,  83,  83,  83,  19,  82,
  82,  82,  85,  85,  85,  85,  84,  84,  17,  15,
  18,  21,   7,  22,  95,  95,  95,  95,  95,  96,
  97,  25,  98,  98,  98,  98,  98, 100,  24, 103,
 103,  23,  23, 105, 105, 105, 105, 105, 105, 105,
 105, 104, 104,  26,  26, 106, 106, 107,  28, 101,
 101, 101, 101, 101, 109, 109, 109, 110, 111, 110,
 114, 108, 113, 113, 112, 112, 112, 112, 115, 115,
 116,  20,  29,  29,  29,  29,  29,  29,  30,  31,
  32,  33,  34,  27,  27,  27,  27,  27,  27, 125,
 128, 123, 130, 132, 124, 121, 134, 135, 122, 120,
 136, 117, 137, 137, 138, 138, 139, 139, 141, 141,
 142, 142,  88,  88,  91,  91, 144, 144, 145, 147,
 146, 148, 148, 148, 127,  38,  62,  62,  92,  92,
 151, 151, 152, 126, 126, 154, 154, 155, 156, 156,
  93,  93, 133, 133, 133,  41,  41,  41,  41,  94,
  94,  94,  94,  94, 158, 158, 159, 159, 160, 160,
  86, 161, 161, 161, 162, 162, 162, 164, 165,  35,
  35,  50,  50, 166, 166, 157, 157, 157, 157, 157,
 157, 157, 157, 157, 157, 157, 157, 157, 157, 157,
 157, 157, 157, 157, 157, 157, 157, 157, 157, 157,
 157, 167, 167, 167, 169, 169, 143, 143, 170, 170,
 172, 173, 129, 129, 129, 129, 174, 174, 174,  39,
  39,  36,  36, 119,  90,  68, 149,  40,  48, 131,
  87, 153,  59, 118,  45,  45,  45,   6, 168, 168,
 168, 168, 168, 168, 171,  79,  79, 163,  64,  76,
 175, 175, 102,  99,  89,  60,  65,  49,  74, 140,
  75,  47, 150, 176 };
short yyr2[]={

   0,   0,   3,   1,   1,   3,   1,   2,   1,   1,
   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
   1,   1,   1,   1,   1,   1,   6,   0,   4,   2,
   5,   7,   1,   1,   0,   2,   0,   1,   0,   1,
  11,   6,   1,   4,   0,   1,   1,   0,   2,   1,
   0,   3,   1,   1,   1,   0,   3,   0,   3,   0,
   4,   0,   4,   1,   3,   2,   3,   3,   1,   1,
   1,   1,   1,   1,   1,   1,   1,   1,   1,   5,
   4,   0,   1,   1,   1,   1,   1,   2,   3,   3,
   1,   1,   3,   2,   4,   0,   1,   1,   4,   0,
   1,   1,   0,   1,   2,   2,   0,   2,  13,   4,
   4,   5,   3,   3,   0,   1,   1,   2,   2,   2,
   2,   3,   1,   1,   1,   1,   1,   2,   6,   1,
   0,   6,   6,   0,   1,   1,   1,   1,   1,   1,
   1,   1,   3,   6,   4,   5,   0,   0,   8,   1,
   1,   2,   2,   0,   1,   1,   3,   1,   0,   3,
   0,   9,   3,   1,   1,   1,   1,   1,   1,   0,
   2,   2,   2,   2,   2,   1,   1,   1,   4,   2,
   2,   2,   1,   1,   1,   1,   1,   1,   1,   0,
   0,  10,   0,   0,   7,   9,   0,   0,  10,   2,
   0,   9,   2,   1,   0,   1,   0,   3,   1,   3,
   2,   2,   0,   1,   1,   1,   3,   1,   2,   4,
   2,   0,   1,   2,   0,   1,   1,   3,   0,   4,
   3,   1,   3,   2,   0,   3,   1,   3,   3,   1,
   0,   2,   0,   2,   2,   0,   2,   2,   2,   1,
   3,   2,   2,   3,   5,   3,   0,   1,   0,   1,
   0,   3,   4,   0,   3,   4,   0,   2,   3,   3,
   1,   1,   0,   0,   2,   2,   1,   2,   3,   3,
   3,   3,   3,   3,   3,   2,   2,   2,   3,   3,
   3,   2,   2,   1,   3,   4,   2,   2,   3,   3,
   2,   4,   6,   0,   1,   3,   3,   3,   1,   3,
   1,   5,   3,   1,   3,   5,   4,   4,   2,   0,
   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
   1,   1,   1,   1 };
short yychk[]={

-1000,  -1,  -2,  -4, 371,  -5, 260,  -7,  -8,  -9,
 -10, -11, -12, -13, -14, -15, -16, -17, -18, -19,
 -20, -21, -22, -23, -24, -25, -26, -27, -28, -29,
 -30, -31, -32, -33, -34, 258, 267, 262, 263, 264,
 265, 266, 269, 272, 273, 274, 275, 374, 276, 277,
 278,-120,-121,-122,-123,-116,-124, 257, 261, 270,
 365, 366, 367, 370, 280, 271, 279, 259, 373, 268,
  -3, 343,  -6, -64, 328,  40, -69, -88, 338, 372,
-101, 354, -74, -75, 286, 356, 355, 362, 339, 340,
 281, -39, -76, 342, -36,-175, -76, 349, 350, -42,
 292, -36, -57, 297, 290, -38, -62, -87, -76, -89,
 304, -82, 297, 290, -94, -36,  40, -82, -36, -36,
 -98,-102, -74, -99, -75, -89,-100, 354, 338, 372,
-101, -68, -36, -76, 332, 332, 332,-118, 328,-119,
 -76,-119,-117,-136,-127,-134,-125, -36,-130,  -1,
  -4, -35,-165, -76, -70, -71, -76, 344,  43,  45,
  42,  47,  60,  62,  61, -89, -70, -70, 327, -87,
 356, 356, -37, 319, -43, -49, 316,  40, 314,  44,
 -40, -76, -83, -79, 282,-163, 346, 343, 302, 124,
  42,-158,  91, -94, -85, -79, 331, -95, -96, -97,
 291, 284, -87, -87, 344,-105,  43,  45,  42,  47,
  60,  62,  61, 327, 303, 331,-126, 298,-133, 375,
 323,-126,-126,-126,  41,  44,  61, -72,  40, -40,
 381, -87,-117, -38, -40, -36, -50, -35, -36, -87,
 -93, 336, -84, 303, -36, -94,-159, -59, -64,  41,
 -84, -79, -86, -97, -96, -59, -59,  40,  40,  40,
 -36, -36,-137, 302,-133,-154,-155,-156,-131, -76,
  40, -87, -87,-127,-127,-127, 331,-165,-164, -87,
 -73, 288, -80, -81, -71, 319, 328,-106,  91, -41,
 335, -44, 331, 298,  41, 298,-157,-143,-168,  45,
  58,  59, 124,  40, 344, -36, -87, 317,-171,-163,
 346, 345, -64,-176, -76, 380, 318, -87,  44,  93,
-103, -62,-104, -87,-104, 331,-138, 334, -36,  44,
 303,  44,-129,-174, -36, -76,-143,-171, -36, -36,
-131, -36,-161,  91, 308,  41,  44,  61, -36, 308,
 -79, 344,  60,  62, -45, 328, 368, 369, -51, -65,
 309, -58, -36,  43,  45,  47,  42,  60,  62,  61,
 344, 376, 377, 285, 321,-167,  91, 357,-157,-157,
-157,-157,-157,-157,  46,  40,-157,  46,-160, -59,
  41,  41,  44,  41, -68, -76,  40,-155, -94,-131,
  41,  44,  46,-167,-167,-135,-128,-132,  93,-163,
  40, -81, -78, -76, 344, -79, -64, 329, -47, 335,
-107,  44, -46, -47, -52, 306,  40,  91,-157,-157,
-157,-157,-157,-157,-157,-157,-157,-157,-157,-164,
  41,-170, -68,  41,-169,-157,-170,  93, -87,-129,
-126,-174, -36, 282,  61,  40,  40, -93,-162,  91,
  93, -77,  41, -62, -76, -90, -76,-108, 319, -79,
 -48, -76, -53, -60, 305,  40, -66, -67, -68, -59,
  93,  58,  46,  41,  44,  41, -92,-150, 337,  46,
-173,-157, -87,-129,-129,  93,-163,-162,  41,  40,
-112, 280, 279, 268, 259,  93, -54, 286, -61, -62,
 -38,  41,  44, -41,  93,-167,-157, -68,-157, -93,
 -93,  40, 282, 123,  41,  41,-162,  93, -91,-144,
-145,-146,-147, -68, -87, -76, 331, -55, 312,  61,
  41, -67,  93,-139,-140, 330,-151,-152, -76,-172,
-143, -36, -93, -93,-162,  41,  44,-148,-149,-150,
 -76,-148,  40,-113, -36, -56, 287,  61, -63, 300,
 311, 315,-167, 293,  41,  44,  61,-166, 336, -92,
-146,-149, -62,-114,  46,  61, -64,-141,-142, -76,
-143,-152,-153, -76, 125,-157, -93,  41, -93, -68,
 -64,  44, -41, -41, 352,-142,-115, 353,-109, -76,
 -27,  91,-110, -27,  93,-111, -27 };
short yydef[]={

   0,  -2,  -2,   4,   0,   6,   0,   8,   9,  10,
  11,  12,  13,  14,  15,  16,  17,  18,  19,  20,
  21,  22,  23,  24,  25,  26,  27,  28,  29,  30,
  31,  32,  33,  34,  35,   0,  -2,   0, 329,   0,
  48,  54,   0,   0, 109,   0, 109,   0,   0, 163,
   0, 193, 194, 195, 196, 197, 198, 185, 186, 187,
   0,   0,   0, 192, 210, 234, 206, 199,   0, 202,
   0,   0,   7, 347, 358,   0,   0,   0,   0,   0,
   0,   0,  78,  79, 223, 159, 160,   0, 368, 370,
  37,  39, 330, 359,   0, 331, 332, 360, 361,  46,
  49,   0,   0,  55,  56, 103, 235, 236, 340,   0,
 364, 105, 110, 111,   0, 259,   0, 112, 181, 124,
   0,   0, 143, 132, 133, 134, 135, 136, 362, 363,
   0,   0,   0,  -2, 182, 183, 184, 189, 343, 190,
 333, 191, 209, 244, 252, 244, 244, 180, 244,   2,
   5,   0, 280,   0,  76,   0,  80,  81,  82,  83,
  84,  85,  86,  87,  88,   0,   0, 122,   0, 210,
 162, 161,   0,   0,   0,  47, 367, 282,   0,   0,
 250, 337, 116, 106, 107, 355, 356, 357,   0,   0,
 261, 262, 266,   0, 116, 113, 270, 123, 125, 126,
   0,   0, 131,   0,   0,   0, 144, 145, 146, 147,
 148, 149, 150, 137,   0,   0, 252,   0,   0,   0,
   0, 234, 234, 234,   0,   0,   0,  91,   0,   0,
   0, 156, 188,  38, 255,   0,   0, 281,   0, 237,
 119,   0, 104,   0, 120, 260,   0, 267, 342, 263,
 108, 114, 115, 127, 128, 129, 130, 140,   0,   0,
   0, 154, 214,   0, 213, 243, 246,   0, 249, 339,
   0, 253, 254,   0,   0,   0,   0, 279, 278, 273,
  77,   0,   0, 101, 100,   0, 121,   0,   0,  40,
   0,   0,  42,  43,  71,   0, 251, 313, 286,   0,
   0,   0,   0,   0,   0, 303,   0,   0, 352, 348,
 349, 350, 351, 353,  -2, 354, 373, 117, 268, 265,
   0, 139,   0, 151,   0,   0,   0, 215, 212,   0,
   0,   0,   0, 323,   0,  -2, 313,   0, 207, 200,
 203,  36, 277,   0,   0,  98,   0,   0,   0, 157,
   0, 256, 257, 258,  44, 344, 345, 346,  69,   0,
 366,  51,  52,   0,   0,   0,   0,   0,   0,   0,
  -2, 306, 307,   0,   0, 285,   0,   0, 287, 295,
 296, 297,   0,  -2,   0,   0, 310,   0,   0, 269,
 138, 141,   0, 142, 153, 335,   0, 245, 247, 248,
 244,   0,   0,   0, 328,   0,   0, 250, 276,   0,
   0, 102,  99,  93,  94,  95,  96,   0,   0, 371,
   0,   0,  41,   0,  57,   0,   0,   0, 288, 289,
 290, 291,  -2,  -2, 294,  -2, 308, 309,   0, 298,
 299, 316, 318, 304,   0, 314, 317, 264, 152,   0,
 238, 322,   0, 324,   0,   0,   0, 204, 271,   0,
 276,   0,  90,  92,  97,   0, 334, 158,   0,   0,
  45, 338,  60,   0, 365,   0,   0,  73, 255,   0,
 313,   0,   0, 305,   0, 250, 250,   0, 372,   0,
 326, 327,   0,   0,   0, 276,   0, 272,  89,   0,
   0, 174, 175, 176, 177, 155,  65,   0,  58,  59,
   0,  72,   0,  75,  53, 311,   0, 319, 315, 216,
 205,   0, 325,   0, 250, 250, 274, 276,   0, 224,
 225, 227, 231, 231,   0,  -2,   0,  67,   0,   0,
  70,  74, 313, 211,   0, 369,   0, 241,   0, 283,
 320,   0, 208, 201, 275, 238,   0, 228, 232,   0,
 336, 230,   0, 170, 173,  50,   0,   0,  61,  62,
  63,  64, 312,   0, 239,   0,   0,   0,   0, 250,
 226, 233,   0, 250,   0,   0,  66, 217, 218,  -2,
 255, 240, 242, 341, 321, 284, 118, 229,   0, 172,
  68,   0, 220, 221, 179, 219,   0, 178, 171, 164,
 165,   0, 168, 167, 166,   0, 169 };
#ifndef lint
static char yaccpar_sccsid[] = "@(#)yaccpar	4.1	(Berkeley)	2/11/83";
#endif

#
# define YYFLAG -1000
# define YYERROR goto yyerrlab
# define YYACCEPT return(0)
# define YYABORT return(1)

/*	parser for yacc output	*/

#ifdef YYDEBUG
int yydebug = 0; /* 1 for debugging */
#endif
YYSTYPE yyv[YYMAXDEPTH]; /* where the values are stored */
int yychar = -1; /* current input token number */
int yynerrs = 0;  /* number of errors */
short yyerrflag = 0;  /* error recovery flag */

yyparse() {

	short yys[YYMAXDEPTH];
	short yyj, yym;
	register YYSTYPE *yypvt;
	register short yystate, *yyps, yyn;
	register YYSTYPE *yypv;
	register short *yyxi;

	yystate = 0;
	yychar = -1;
	yynerrs = 0;
	yyerrflag = 0;
	yyps= &yys[-1];
	yypv= &yyv[-1];

 yystack:    /* put a state and value onto the stack */

#ifdef YYDEBUG
	if( yydebug  ) printf( "state %d, char 0%o\n", yystate, yychar );
#endif
		if( ++yyps> &yys[YYMAXDEPTH] ) { yyerror( "yacc stack overflow" ); return(1); }
		*yyps = yystate;
		++yypv;
		*yypv = yyval;

 yynewstate:

	yyn = yypact[yystate];

	if( yyn<= YYFLAG ) goto yydefault; /* simple state */

	if( yychar<0 ) if( (yychar=yylex())<0 ) yychar=0;
	if( (yyn += yychar)<0 || yyn >= YYLAST ) goto yydefault;

	if( yychk[ yyn=yyact[ yyn ] ] == yychar ){ /* valid shift */
		yychar = -1;
		yyval = yylval;
		yystate = yyn;
		if( yyerrflag > 0 ) --yyerrflag;
		goto yystack;
		}

 yydefault:
	/* default state action */

	if( (yyn=yydef[yystate]) == -2 ) {
		if( yychar<0 ) if( (yychar=yylex())<0 ) yychar = 0;
		/* look through exception table */

		for( yyxi=yyexca; (*yyxi!= (-1)) || (yyxi[1]!=yystate) ; yyxi += 2 ) ; /* VOID */

		while( *(yyxi+=2) >= 0 ){
			if( *yyxi == yychar ) break;
			}
		if( (yyn = yyxi[1]) < 0 ) return(0);   /* accept */
		}

	if( yyn == 0 ){ /* error */
		/* error ... attempt to resume parsing */

		switch( yyerrflag ){

		case 0:   /* brand new error */

			yyerror( "syntax error" );
		yyerrlab:
			++yynerrs;

		case 1:
		case 2: /* incompletely recovered error ... try again */

			yyerrflag = 3;

			/* find a state where "error" is a legal shift action */

			while ( yyps >= yys ) {
			   yyn = yypact[*yyps] + YYERRCODE;
			   if( yyn>= 0 && yyn < YYLAST && yychk[yyact[yyn]] == YYERRCODE ){
			      yystate = yyact[yyn];  /* simulate a shift of "error" */
			      goto yystack;
			      }
			   yyn = yypact[*yyps];

			   /* the current yyps has no shift onn "error", pop stack */

#ifdef YYDEBUG
			   if( yydebug ) printf( "error recovery pops state %d, uncovers %d\n", *yyps, yyps[-1] );
#endif
			   --yyps;
			   --yypv;
			   }

			/* there is no state on the stack with an error shift ... abort */

	yyabort:
			return(1);


		case 3:  /* no shift yet; clobber input char */

#ifdef YYDEBUG
			if( yydebug ) printf( "error recovery discards char %d\n", yychar );
#endif

			if( yychar == 0 ) goto yyabort; /* don't discard EOF, quit */
			yychar = -1;
			goto yynewstate;   /* try again in the same state */

			}

		}

	/* reduction by production yyn */

#ifdef YYDEBUG
		if( yydebug ) printf("reduce %d\n",yyn);
#endif
		yyps -= yyr2[yyn];
		yypvt = yypv;
		yypv -= yyr2[yyn];
		yyval = yypv[1];
		yym=yyn;
			/* consult goto table to find next state */
		yyn = yyr1[yyn];
		yyj = yypgo[yyn] + *yyps + 1;
		if( yyj>=YYLAST || yychk[ yystate = yyact[yyj] ] != -yyn ) yystate = yyact[yypgo[yyn]];
		switch(yym){
			
case 1:
# line 145 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ parser_init(param_type_info, pfunc_num_args); } break;
case 2:
# line 147 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ parsetree = lispCons ( yypvt[-2] , parsetree ) ; } break;
case 3:
# line 149 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ 
		    parsetree = lispCons(yypvt[-0],LispNil) ; 
		    parser_init(param_type_info, pfunc_num_args);
		} break;
case 5:
# line 157 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		    yyval = nappend1(yypvt[-0], yypvt[-1]);
		} break;
case 36:
# line 206 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		     yyval = lispCons( yypvt[-0] , yypvt[-3]);
		     yyval = lispCons( KW(addattr) , yyval);
		} break;
case 37:
# line 223 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		extern char *Ch;
		LispValue aclitem_lv, modechg_lv;

		aclitem_lv = lispVectori(sizeof(AclItem));
		modechg_lv = lispInteger(0);
		Ch = aclparse(Ch,
			      (AclItem *) LISPVALUE_BYTEVECTOR(aclitem_lv),
			      &modechg_lv->val.fixnum);
		temp = lispCons(aclitem_lv,
				lispCons(modechg_lv, LispNil));
	} break;
case 38:
# line 236 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
			yyval = lispCons(KW(change),
				      lispCons(KW(acl),
					       nconc(temp, yypvt[-0])));
		} break;
case 39:
# line 253 "/usr/local/src/postgres/src/backend/parser/gram.y"
{  yyval = MakeList ( KW(close), yypvt[-0], -1 ); } break;
case 40:
# line 267 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ elog(WARN,"cluster statement unimplemented in version 2"); } break;
case 41:
# line 287 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		    LispValue temp;
		    yyval = lispCons( KW(copy), LispNil);
		    yypvt[-3] = lispCons(yypvt[-3],LispNil);
		    yypvt[-3] = nappend1(yypvt[-3],yypvt[-5]);
		    yypvt[-3] = nappend1(yypvt[-3],yypvt[-4]);
		    yyval = nappend1(yyval,yypvt[-3]);
		    yyval = nappend1(yyval,lispCons (yypvt[-2],lispCons(yypvt[-1],LispNil)));
		    if(! lispNullp(yypvt[-0]))
		      yypvt[-0] = lispCons(yypvt[-0],LispNil);
		    yyval = nappend1(yyval, lispCons(KW(using), yypvt[-0]));
		    temp = yyval;
		    while(temp != LispNil && CDR(temp) != LispNil )
		      temp = CDR(temp);
		    CDR(temp) = LispNil;
		} break;
case 42:
# line 307 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = KW(to); } break;
case 43:
# line 309 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = KW(from); } break;
case 44:
# line 313 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ NULLTREE } break;
case 45:
# line 314 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = yypvt[-0] ; } break;
case 46:
# line 318 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ NULLTREE } break;
case 48:
# line 323 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ NULLTREE } break;
case 49:
# line 324 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = KW(binary); } break;
case 50:
# line 332 "/usr/local/src/postgres/src/backend/parser/gram.y"
{

		     LispValue temp = LispNil;

		     yypvt[-0] = lispCons (yypvt[-0], LispNil);
		     yypvt[-1] = lispCons (yypvt[-1], yypvt[-0]);
		     yypvt[-2] = lispCons ( yypvt[-2], yypvt[-1]);
		     yypvt[-3] = lispCons ( yypvt[-3], yypvt[-2] );
		     yypvt[-4] = lispCons ( yypvt[-4], yypvt[-3] );
		     yypvt[-5] = lispCons ( yypvt[-5], yypvt[-4] );
		     
		     yypvt[-9] = lispCons ( yypvt[-9], LispNil );
		     yyval = lispCons ( KW(create), yypvt[-9] );
		     
		     yyval = nappend1 ( yyval, yypvt[-5] );
		     temp = yyval;

		     while (CDR(temp) != LispNil) 
		       temp = CDR(temp);

		     CDR(temp) = yypvt[-7];
		} break;
case 51:
# line 356 "/usr/local/src/postgres/src/backend/parser/gram.y"
{   
		    yyval = MakeList ( yypvt[-4], yypvt[-2], yypvt[-0],-1 );
		} break;
case 53:
# line 362 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = MakeList( yypvt[-3], yypvt[-1], -1); } break;
case 54:
# line 366 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = KW(forward);} break;
case 55:
# line 367 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = KW(forward); } break;
case 56:
# line 368 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = KW(backward); } break;
case 57:
# line 373 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ NULLTREE } break;
case 58:
# line 375 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispCons ( yypvt[-1] , yypvt[-0] ); } break;
case 60:
# line 381 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ NULLTREE } break;
case 61:
# line 383 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispCons (KW(archive) , yypvt[-0]); } break;
case 62:
# line 387 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = KW(heavy); } break;
case 63:
# line 388 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = KW(light); } break;
case 64:
# line 389 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = KW(none); } break;
case 65:
# line 393 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ NULLTREE } break;
case 66:
# line 395 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		    int which;

		    which = smgrin(LISPVALUE_STRING(yypvt[-0]));
		    yyval = lispCons(KW(store), lispInteger(which));
		} break;
case 67:
# line 404 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ NULLTREE } break;
case 68:
# line 406 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		    int which;

		    which = smgrin(LISPVALUE_STRING(yypvt[-0]));
		    yyval = lispCons(KW(arch_store), lispInteger(which));
		} break;
case 69:
# line 415 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ NULLTREE } break;
case 70:
# line 417 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ 
		    yyval = lispCons ( KW(inherits), yypvt[-1] ) ; 
		} break;
case 71:
# line 424 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ NULLTREE } break;
case 72:
# line 426 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ 
		    yyval = MakeList ( yypvt[-3], yypvt[-1], -1 );
		} break;
case 73:
# line 432 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ ELEMENT ; } break;
case 74:
# line 433 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ INC_LIST ;  } break;
case 75:
# line 438 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		  yyval = lispCons(yypvt[-1],lispCons(yypvt[-0],LispNil)) ;
		} break;
case 76:
# line 452 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		   yypvt[-1] = lispCons (yypvt[-1] , yypvt[-0] ); 
		   yyval = lispCons (KW(define) , yypvt[-1] ); 
		} break;
case 77:
# line 460 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		   if ( yypvt[-0] != LispNil ) 
			yypvt[-1] = nappend1 (yypvt[-1], yypvt[-0] );
		   yyval = lispCons (yypvt[-2] , yypvt[-1] );
		} break;
case 82:
# line 470 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispString("+"); } break;
case 83:
# line 471 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispString("-"); } break;
case 84:
# line 472 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispString("*"); } break;
case 85:
# line 473 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispString("/"); } break;
case 86:
# line 474 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispString("<"); } break;
case 87:
# line 475 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispString(">"); } break;
case 88:
# line 476 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispString("="); } break;
case 89:
# line 481 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispCons (KW(arg), yypvt[-1]); } break;
case 90:
# line 483 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispCons (KW(arg), LispNil); } break;
case 91:
# line 485 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ NULLTREE } break;
case 97:
# line 495 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispCons(KW(setof), yypvt[-0]); } break;
case 98:
# line 500 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = yypvt[-1]; } break;
case 99:
# line 505 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispCons(yypvt[-2], lispCons(yypvt[-0], LispNil)); } break;
case 100:
# line 507 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispCons(yypvt[-0], LispNil); } break;
case 101:
# line 511 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ ELEMENT ; } break;
case 102:
# line 512 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ INC_LIST ;  } break;
case 103:
# line 524 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispCons( KW(destroy) ,yypvt[-0]) ; } break;
case 104:
# line 537 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		    yyval = MakeList ( KW(fetch), yypvt[-0], yypvt[-2], yypvt[-1], -1 );
	        } break;
case 105:
# line 544 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = KW(all) ; } break;
case 107:
# line 547 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = KW(all) ; } break;
case 108:
# line 559 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ 
		    yyval = MakeList ( KW(move), yypvt[-0], yypvt[-2], yypvt[-1], -1 );
		} break;
case 109:
# line 565 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = KW(forward); } break;
case 110:
# line 567 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = KW(forward); } break;
case 111:
# line 569 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = KW(backward); } break;
case 112:
# line 573 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ NULLTREE } break;
case 114:
# line 576 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = MakeList ( KW(to), yypvt[-0], -1 ); } break;
case 115:
# line 578 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispString("record quals unimplemented") ; } break;
case 116:
# line 582 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ NULLTREE } break;
case 117:
# line 583 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = yypvt[-0];} break;
case 118:
# line 602 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		    /* should check that access_method is valid,
		       etc ... but doesn't */

		    yyval = lispCons ( yypvt[-0], lispCons ( p_rtable, NULL )); 
		    yyval = MakeList ( yypvt[-7],yypvt[-9],yypvt[-5],yypvt[-3],yypvt[-1],yyval,-1 );
		    yyval = lispCons(KW(index),yyval);
		    yyval = lispCons(KW(define),yyval);
		} break;
case 119:
# line 624 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		    yyval = lispCons ( yypvt[-0], lispCons ( p_rtable, NULL )); 
		    yyval = MakeList ( yypvt[-1],yyval,-1 );
		    yyval = lispCons(KW(extend),yyval);
		} break;
case 120:
# line 642 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ 
		    yyval = MakeList ( yypvt[-3], yypvt[-2], yypvt[-0], -1 );
		    elog(WARN, "merge is unsupported in version 4");
		} break;
case 121:
# line 666 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		    yyval = lispCons(yypvt[-0], LispNil);
		    yyval = lispCons(yypvt[-2], yyval);
		    yyval = lispCons(KW(function), yyval);
		    yyval = lispCons(KW(define), yyval);
		} break;
case 122:
# line 675 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
	    yyval = lispCons( KW(aggregate), yypvt[-0]);
	    yyval = lispCons( KW(define), yyval);
	} break;
case 123:
# line 695 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ 
		  yyval = lispCons ( yypvt[-0], LispNil );
		  yyval = lispCons ( yypvt[-1], yyval );
		  yyval = lispCons ( KW(purge), yyval );
		} break;
case 124:
# line 704 "/usr/local/src/postgres/src/backend/parser/gram.y"
{yyval=lispList();} break;
case 125:
# line 706 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispCons ( yypvt[-0], LispNil ); } break;
case 126:
# line 708 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispCons ( yypvt[-0], LispNil ); } break;
case 127:
# line 710 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = MakeList ( yypvt[-1], yypvt[-0] , -1 ); } break;
case 128:
# line 712 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = MakeList ( yypvt[-0], yypvt[-1], -1 ); } break;
case 129:
# line 715 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = MakeList ( KW(before),yypvt[-0],-1); } break;
case 130:
# line 716 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = MakeList ( KW(after),yypvt[-0],-1 ); } break;
case 131:
# line 737 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		    yyval = MakeList ( KW(remove), yypvt[-1], yypvt[-0] , -1 ); 
		} break;
case 137:
# line 747 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ 
			/*
			 * the rule type can be either
			 * P_TYPE or REWRITE
			 */
			yyval = CAR(yypvt[-1]);
		} break;
case 138:
# line 758 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		    yyval  = lispCons(yypvt[-3], yypvt[-1]);
		    yyval  = lispCons(yypvt[-4], lispCons(yyval, LispNil));
		    yyval  = lispCons( KW(remove) , yyval);
	        } break;
case 139:
# line 767 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		    yyval  = lispCons(lispInteger(length(yypvt[-0])), yypvt[-0]);
	        } break;
case 140:
# line 771 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		    yyval  = lispCons(lispInteger(0), LispNil);
	        } break;
case 141:
# line 778 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		    yyval  = lispCons(yypvt[-3], yypvt[-1]);
		    yyval  = lispCons(yypvt[-4], lispCons(yyval, LispNil));
		    yyval  = lispCons( KW(remove) , yyval);
		} break;
case 142:
# line 784 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
                    yyval  = lispCons(yypvt[-3], yypvt[-1]);
                    yyval  = lispCons(yypvt[-4], lispCons(yyval, LispNil));
                    yyval  = lispCons( KW(remove) , yyval);
                } break;
case 144:
# line 791 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispString("+"); } break;
case 145:
# line 792 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispString("-"); } break;
case 146:
# line 793 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispString("*"); } break;
case 147:
# line 794 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispString("/"); } break;
case 148:
# line 795 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispString("<"); } break;
case 149:
# line 796 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispString(">"); } break;
case 150:
# line 797 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispString("="); } break;
case 151:
# line 802 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispCons(yypvt[-0], LispNil); } break;
case 152:
# line 804 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = MakeList ( yypvt[-2], yypvt[-0], -1 ); } break;
case 153:
# line 818 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ 
		    yyval = MakeList ( KW(rename), lispString("ATTRIBUTE"),
				    yypvt[-2], yypvt[-4], yypvt[-0], -1 );
		} break;
case 154:
# line 823 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		    yyval = MakeList ( KW(rename), lispString("RELATION"),
				    yypvt[-2], yypvt[-0], -1 );
		} break;
case 155:
# line 836 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		    yyval = lispCons ( yypvt[-3], yypvt[-1] );
		} break;
case 156:
# line 840 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		    yyval = lispCons ( lispFloat(1.0), lispFloat(0.0) );
		} break;
case 157:
# line 847 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		    p_ruleinfo = lispCons(lispInteger(0),LispNil);
		    p_priority = lispInteger(0) ;
		} break;
case 158:
# line 852 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		    if ( CAtom(CAR(yypvt[-6]))==P_TUPLE) {
			/* XXX - do the bogus fix to get param nodes
			         to replace varnodes that have current 
				 in them */
			/*==== XXX
			 * LET THE TUPLE-LEVEL RULE MANAGER DO
			 * THE SUBSTITUTION....
			SubstituteParamForNewOrCurrent ( $8 );
			 *====
			 */
			yyval = lispCons ( yypvt[-0], lispCons ( p_rtable, NULL )); 
			yyval = lispCons ( yypvt[-4], yyval ); 
			if (null(CDR(yypvt[-6]))) {
			    List t;
			    t = lispCons(LispNil, LispNil);
			    t = lispCons(KW(rule), t);
			    yyval = lispCons(t, yyval);
			} else {
			    List t;
			    t = lispCons(CADR(yypvt[-6]), LispNil); 
			    t = lispCons(KW(rule), t); 
			    yyval = lispCons(t, yyval); 
			}
			yyval = lispCons ( CAR(yypvt[-6]), yyval );
			yyval = lispCons ( KW(define), yyval ); 
		    } else {
			yyval = nappend1 ( yypvt[-0], yypvt[-3] );
			yyval = lispCons ( yypvt[-4], yyval );
			yyval = lispCons ( KW(rule), yyval );	
			yyval = lispCons ( CAR(yypvt[-6]), yyval ); 
			yyval = lispCons ( KW(define), yyval );
		    }
		} break;
case 159:
# line 907 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispCons(KW(instance), LispNil); } break;
case 160:
# line 909 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispCons(KW(rewrite), LispNil); } break;
case 161:
# line 911 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		    yyval = lispCons(KW(relation), LispNil);
		    yyval = lispCons(KW(instance), yyval);
		} break;
case 162:
# line 916 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		    yyval = lispCons(KW(instance), LispNil);
		    yyval = lispCons(KW(instance), yyval);
		} break;
case 163:
# line 921 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispCons(KW(instance), LispNil); } break;
case 164:
# line 926 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ 
		  if ( ! strcmp(CString(yypvt[-0]),"nothing") ) {
			yyval = LispNil;
		  } else
			elog(WARN,"bad rule action %s", CString(yypvt[-0]));
		} break;
case 165:
# line 933 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispCons ( yypvt[-0], LispNil ); } break;
case 166:
# line 935 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = yypvt[-1]; } break;
case 167:
# line 940 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ ELEMENT ;} break;
case 168:
# line 942 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
                  p_last_resno = 1;
                  p_target_resnos = LispNil;
		  p_target = LispNil;
               } break;
case 169:
# line 948 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = nappend1(yypvt[-2], yypvt[-0]); } break;
case 170:
# line 955 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ 
	    /* XXX - figure out how to add a from_clause into this
	             rule thing properly.  Spyros/Greg's bogus
		     fix really breaks things, so I had to axe it. */

	    NewOrCurrentIsReally = yypvt[-0];
	   /*
	    * NOTE: 'CURRENT' must always have a varno
	    * equal to 1 and 'NEW' equal to 2.
	    */
	    ADD_TO_RT ( MakeRangeTableEntry ( (Name)CString(CAR(yypvt[-0])), 
					     LispNil,
					     (Name)"*CURRENT*" ) );
	    ADD_TO_RT ( MakeRangeTableEntry ( (Name)CString(CAR(yypvt[-0])), 
					     LispNil,
					     (Name)"*NEW*" ));
	    QueryIsRule = true;
	} break;
case 171:
# line 976 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
	    yyval = MakeList ( yypvt[-7], yypvt[-5], yypvt[-3], yypvt[-1], yypvt[-0], -1 );
	    /* modify the rangetable entry for "current" and "new" */
	} break;
case 172:
# line 984 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = MakeList ( yypvt[-2], yypvt[-0], -1 ); } break;
case 173:
# line 986 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispCons ( yypvt[-0], LispNil ); } break;
case 178:
# line 992 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispInteger((int)true); } break;
case 179:
# line 993 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispInteger((int)false); } break;
case 180:
# line 1000 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		LispValue root;
		int x = 0;
		    
		elog(WARN,
		     "notify is turned off for 4.0.1 - see the release notes");
		if((x=RangeTablePosn(CString(yypvt[-0]),LispNil)) == 0 )
		  ADD_TO_RT (MakeRangeTableEntry ((Name)CString(yypvt[-0]),
						  LispNil,
						  (Name)CString(yypvt[-0])));
		    
		if (x==0)
		  x = RangeTablePosn(CString(yypvt[-0]),LispNil);
		
		parser_current_rel = heap_openr(VarnoGetRelname(x));
		if (parser_current_rel == NULL)
		  elog(WARN,"notify: relation %s doesn't exist",CString(yypvt[-0]));
		else
		  heap_close(parser_current_rel);

		root = MakeRoot(1,
				KW(notify),
				lispInteger(x), /* result relation */
				p_rtable, /* range table */
				p_priority, /* priority */
				p_ruleinfo, /* rule info */
				LispNil, /* unique flag */
				LispNil, /* sort clause */
				LispNil); /* target list */
		yyval = lispCons ( root , LispNil );
		yyval = nappend1 ( yyval , LispNil ); /*  */
		yyval = nappend1 ( yyval , LispNil ); /*  */
	    } break;
case 181:
# line 1036 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		elog(WARN,
		     "listen is turned off for 4.0.1 - see the release notes");
		parser_current_rel = heap_openr(CString(yypvt[-0]));
		if (parser_current_rel == NULL)
		  elog(WARN,"listen: relation %s doesn't exist",yypvt[-0]);
		else
		  heap_close(parser_current_rel);

		yyval = MakeList(KW(listen),yypvt[-0],-1);
	    } break;
case 182:
# line 1063 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispCons ( KW(abort), LispNil ) ; } break;
case 183:
# line 1065 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispCons ( KW(begin), LispNil ) ; } break;
case 184:
# line 1067 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispCons ( KW(end), LispNil ) ; } break;
case 185:
# line 1069 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispCons ( KW(abort), LispNil ) ; } break;
case 186:
# line 1071 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispCons ( KW(begin), LispNil ) ; } break;
case 187:
# line 1073 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispCons ( KW(end), LispNil ) ; } break;
case 188:
# line 1086 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ 
		    yypvt[-1] = lispCons ( yypvt[-1] , yypvt[-0] );
		    yypvt[-2] = lispCons ( KW(view) , yypvt[-1] );
		    yyval = lispCons ( KW(define) , yypvt[-2] );
		} break;
case 189:
# line 1102 "/usr/local/src/postgres/src/backend/parser/gram.y"
{  yyval = MakeList ( KW(load), yypvt[-0], -1 ); } break;
case 190:
# line 1114 "/usr/local/src/postgres/src/backend/parser/gram.y"
{  yyval = MakeList ( KW(createdb), yypvt[-0], -1 ); } break;
case 191:
# line 1126 "/usr/local/src/postgres/src/backend/parser/gram.y"
{  yyval = MakeList ( KW(destroydb), yypvt[-0], -1 ); } break;
case 192:
# line 1138 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = MakeList(KW(vacuum), -1); } break;
case 199:
# line 1174 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ SkipForwardToFromList(); } break;
case 200:
# line 1177 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
                   int x = 0;
                   if((x=RangeTablePosn(CString(yypvt[-0]),LispNil)) == 0)
		     		ADD_TO_RT( MakeRangeTableEntry((Name)CString(yypvt[-0]),
						    LispNil,
						    (Name)CString(yypvt[-0])));
                  if (x==0)
                    x = RangeTablePosn(CString(yypvt[-0]),LispNil);
                  parser_current_rel = heap_openr(VarnoGetRelname(x));
                  if (parser_current_rel == NULL)
                        elog(WARN,"invalid relation name");
                  ResdomNoIsAttrNo = true;
				  parser_current_query = APPEND;
                } break;
case 201:
# line 1193 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
                        LispValue root;
			LispValue command;
                        int x = RangeTablePosn(CString(yypvt[-5]),LispNil);

			if ( yypvt[-6] == LispNil )
			  command = KW(append);
			else
			  command = lispCons( lispInteger('*'),KW(append));

                        root = MakeRoot(1, command , lispInteger(x),
                                        p_rtable,
                                        p_priority, p_ruleinfo,
					LispNil,LispNil,yypvt[-2]);
                        yyval = lispCons ( root , LispNil );
                        yyval = nappend1 ( yyval , yypvt[-2] ); /* (eq p_target $8) */
                        yyval = nappend1 ( yyval , yypvt[-0] ); /* (eq p_qual $10 */
                        ResdomNoIsAttrNo = false;
			heap_close(parser_current_rel);
                } break;
case 202:
# line 1227 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ SkipForwardToFromList(); } break;
case 203:
# line 1230 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		    int x = 0;
		    
		    if((x=RangeTablePosn(CString(yypvt[-0]),LispNil)) == 0 )
                      ADD_TO_RT (MakeRangeTableEntry ((Name)CString(yypvt[-0]),
						      LispNil,
						      (Name)CString(yypvt[-0])));
		    
		    if (x==0)
		      x = RangeTablePosn(CString(yypvt[-0]),LispNil);
		    
		    parser_current_rel = heap_openr(VarnoGetRelname(x));
		    if (parser_current_rel == NULL)
		      elog(WARN,"invalid relation name");
		    else
		      heap_close(parser_current_rel);
		    /* ResdomNoIsAttrNo = true;  */
		} break;
case 204:
# line 1249 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		    LispValue root = LispNil;
		    LispValue command = LispNil;
		    int x = 0;

		    x= RangeTablePosn(CString(yypvt[-2]),LispNil);
		    if (x == 0)
		      ADD_TO_RT(MakeRangeTableEntry ((Name)CString (yypvt[-2]),
						     LispNil,
						     (Name)CString(yypvt[-2])));
		    if ( yypvt[-3] == LispNil )
		      command = KW(delete);
		    else
		      command = lispCons( lispInteger('*'),KW(delete));
		    
		    root = MakeRoot(1,command,
				    lispInteger ( x ) ,
				    p_rtable, p_priority, p_ruleinfo,
				    LispNil,LispNil,LispNil);
		    yyval = lispCons ( root , LispNil );

		    /* check that var_name is in the relation */

		    yyval = nappend1 ( yyval , LispNil ); 	/* no target list */
		    yyval = nappend1 ( yyval , yypvt[-0] ); 		/* (eq p_qual $7 */
                } break;
case 205:
# line 1288 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ 
			yyval = KW(execute);
		  	elog(WARN, "execute does not work in Version 1");
		} break;
case 206:
# line 1304 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ SkipForwardToFromList(); } break;
case 207:
# line 1307 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
                   int x = 0;
                   if((x=RangeTablePosn(CString(yypvt[-0]),LispNil) ) == 0 )
		     		ADD_TO_RT( MakeRangeTableEntry ((Name)CString(yypvt[-0]),
						     LispNil,
						     (Name)CString(yypvt[-0])));
                  if (x==0)
                    x = RangeTablePosn(CString(yypvt[-0]),LispNil);
                  parser_current_rel = heap_openr(VarnoGetRelname(x));
                  if (parser_current_rel == NULL)
                        elog(WARN,"invalid relation name");
                  ResdomNoIsAttrNo = true; 
				  parser_current_query = REPLACE;
				} break;
case 208:
# line 1322 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
                    LispValue root;
		    LispValue command = LispNil;
                    int result = RangeTablePosn(CString(yypvt[-5]),LispNil);
                    if (result < 1)
                      elog(WARN,"parser internal error , bogus relation");
		    if ( yypvt[-6] == LispNil )
		      command = KW(replace);
		    else
		      command = lispCons( lispInteger('*'),KW(replace));

                    root = MakeRoot(1, command , lispInteger(result),
                                    p_rtable,
                                    p_priority, p_ruleinfo,
				    LispNil,LispNil,yypvt[-2]);

                    yyval = lispCons( root , LispNil );
                    yyval = nappend1 ( yyval , yypvt[-2] );          /* (eq p_target $6) */
                    yyval = nappend1 ( yyval , yypvt[-0] );         /* (eq p_qual $9) */
                    ResdomNoIsAttrNo = false;
		    heap_close(parser_current_rel);
                } break;
case 209:
# line 1362 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = yypvt[-0] ; } break;
case 210:
# line 1366 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ SkipForwardToFromList(); } break;
case 211:
# line 1371 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		/* XXX - what to do with opt_unique, from_clause
		 */	
		    LispValue root;
		    LispValue command;

		    command = KW(retrieve);

		    root = MakeRoot(NumLevels,command, yypvt[-6], p_rtable,
				    p_priority, p_ruleinfo,yypvt[-5],yypvt[-0],yypvt[-3]);
		    

		    yyval = lispCons( root , LispNil );
		    yyval = nappend1 ( yyval , yypvt[-3] );
		    yyval = nappend1 ( yyval , yypvt[-1] );
		} break;
case 212:
# line 1401 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
			yypvt[-0]=lispCons(yypvt[-0] , LispNil );
			/* should check for archive level */
			yyval=lispCons(KW(into), yypvt[-0]);
		} break;
case 214:
# line 1412 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ NULLTREE } break;
case 215:
# line 1414 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = KW(unique); } break;
case 216:
# line 1419 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ NULLTREE } break;
case 217:
# line 1421 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = yypvt[-0] ; } break;
case 218:
# line 1425 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ ELEMENT ; } break;
case 219:
# line 1426 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ INC_LIST ;  } break;
case 220:
# line 1431 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispCons ( yypvt[-1], lispCons (yypvt[-0], LispNil )) ; } break;
case 221:
# line 1433 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ /* i had to do this since a bug in yacc wouldn't catch */
                  /* this syntax error - ron choi 4/11/91 */
                  yyerror("syntax error: use \"sort by attribute_name\"");
                } break;
case 222:
# line 1443 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ NULLTREE } break;
case 223:
# line 1445 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = KW(archive); } break;
case 225:
# line 1450 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ ELEMENT ; } break;
case 226:
# line 1453 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ INC_LIST ;  } break;
case 227:
# line 1454 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ ELEMENT ; } break;
case 228:
# line 1459 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = nappend1(LispNil,yypvt[-1]); nappend1(yyval,yypvt[-0]); } break;
case 229:
# line 1464 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = nappend1(LispNil,yypvt[-3]); rplacd(yyval,yypvt[-1]); } break;
case 230:
# line 1469 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = nappend1(LispNil,yypvt[-1]); nappend1(yyval,yypvt[-0]);} break;
case 231:
# line 1472 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ NULLTREE; } break;
case 233:
# line 1475 "/usr/local/src/postgres/src/backend/parser/gram.y"
{yyval=yypvt[-0];} break;
case 234:
# line 1484 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ NULLTREE } break;
case 236:
# line 1490 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ ELEMENT ; } break;
case 237:
# line 1491 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ INC_LIST ;  } break;
case 238:
# line 1502 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ NULLTREE } break;
case 239:
# line 1503 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = MakeList ( yypvt[-3],yypvt[-1],-1 ); } break;
case 240:
# line 1507 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ INC_LIST ;  } break;
case 241:
# line 1508 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ ELEMENT ; } break;
case 242:
# line 1513 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = MakeList ( yypvt[-2], yypvt[-0], -1 ); } break;
case 243:
# line 1518 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ 
			yyval = yypvt[-0] ; 
			SkipBackToTlist();
			yychar = -1;
			/* goto yynewstate; */
		} break;
case 244:
# line 1524 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ NULLTREE ; } break;
case 245:
# line 1528 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ INC_LIST ;  } break;
case 246:
# line 1529 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ ELEMENT ; } break;
case 247:
# line 1534 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		    extern List MakeFromClause ();
		    yyval = MakeFromClause ( yypvt[-2], yypvt[-0] );
		} break;
case 248:
# line 1540 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ INC_LIST ;  } break;
case 249:
# line 1541 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ ELEMENT ; } break;
case 250:
# line 1546 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ NULLTREE } break;
case 251:
# line 1548 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		if (CInteger(CAR(yypvt[-0])) != BOOLOID)
		    elog(WARN,
			 "where clause must return type bool, not %s",
			 tname(get_id_type(CInteger(CAR(yypvt[-0])))));
		p_qual = yyval = CDR(yypvt[-0]);
	    } break;
case 252:
# line 1560 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ NULLTREE } break;
case 253:
# line 1562 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		    /*
		     *  15 august 1991 -- since 3.0 postgres does locking
		     *  right, we discovered that portals were violating
		     *  locking protocol.  portal locks cannot span xacts.
		     *  as a short-term fix, we installed the check here. 
		     *				-- mao
		     */
		    if (!IsTransactionBlock())
			elog(WARN, "Named portals may only be used in begin/end transaction blocks.");

		    yyval = MakeList ( KW(iportal), yypvt[-0], -1 ); 
		} break;
case 254:
# line 1576 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		    /*
		     *  15 august 1991 -- since 3.0 postgres does locking
		     *  right, we discovered that portals were violating
		     *  locking protocol.  portal locks cannot span xacts.
		     *  as a short-term fix, we installed the check here. 
		     *				-- mao
		     */
		    if (!IsTransactionBlock())
			elog(WARN, "Named portals may only be used in begin/end transaction blocks.");

		    yyval = MakeList ( KW(portal), yypvt[-0], -1 ); 
		} break;
case 255:
# line 1592 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ NULLTREE } break;
case 256:
# line 1593 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = yypvt[-0]; } break;
case 257:
# line 1594 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispString("<"); } break;
case 258:
# line 1595 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispString(">"); } break;
case 259:
# line 1600 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ 
		    /* normal relations */
		    yyval = lispCons ( MakeList ( yypvt[-0], LispNil , LispNil , -1 ),
				   LispNil );
		} break;
case 260:
# line 1606 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ 
		    /* union'ed relations */
		    elog ( DEBUG, "now consing the union'ed relations");
		    yyval = append ( yypvt[-2], yypvt[-0] );
		} break;
case 261:
# line 1612 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ 
		    /* inheiritance query */
		    yyval = lispCons ( MakeList ( yypvt[-1], LispNil, 
					      lispString("*"), -1) ,
				   LispNil );
		} break;
case 262:
# line 1619 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ 
		    /* time-qualified query */
		    yyval = lispCons ( MakeList ( yypvt[-1], yypvt[-0], LispNil , -1 ) ,
				    LispNil );
		} break;
case 263:
# line 1625 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ 
		    elog( DEBUG, "now reducing by parentheses");
		    yyval = yypvt[-1]; 
		} break;
case 264:
# line 1634 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ 
		    yyval = MakeList ( yypvt[-3], yypvt[-1], lispInteger(1), -1 );
		} break;
case 265:
# line 1638 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ 
		    yyval = MakeList ( yypvt[-1] , LispNil, lispInteger(0), -1 );
		} break;
case 266:
# line 1645 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispString("epoch"); } break;
case 268:
# line 1651 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispString("now"); } break;
case 270:
# line 1657 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ NULLTREE } break;
case 271:
# line 1661 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ 
			int ndim = 0;
			IntArray dim_upper, dim_lower;
			List elt, list;
			
			list = lispCons(lispInteger(-1), yypvt[-0]);
			foreach (elt, list) {
				dim_upper.indx[ndim] = CInteger(CAR(elt));
				dim_lower.indx[ndim++] = 0;
			}	
				
		    yyval = (LispValue) MakeArray((ObjectId) 0, 0, false, ndim, 
					dim_lower, dim_upper, 0);
		} break;
case 272:
# line 1676 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ 
			int ndim = 0;
			IntArray dim_upper, dim_lower;
			List elt, list;
			
			list = lispCons(yypvt[-2], yypvt[-0]);
			foreach (elt, list) {
				dim_upper.indx[ndim] = CInteger(CAR(elt));
				dim_lower.indx[ndim++] = 0;
			}	
				
		    yyval = (LispValue) MakeArray((ObjectId) 0, 0, false, ndim, 
					dim_lower, dim_upper, 0);
		} break;
case 273:
# line 1690 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ NULLTREE } break;
case 274:
# line 1695 "/usr/local/src/postgres/src/backend/parser/gram.y"
{	yyval = lispCons(lispInteger(-1), yypvt[-0]); } break;
case 275:
# line 1697 "/usr/local/src/postgres/src/backend/parser/gram.y"
{yyval = lispCons(yypvt[-2], yypvt[-0]); } break;
case 276:
# line 1698 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ NULLTREE } break;
case 277:
# line 1702 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispCons(yypvt[-1],yypvt[-0]); } break;
case 278:
# line 1707 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ 
		    ObjectId typrelid;

		    /* for 4.0, attributes cannot have complex types */
		    typrelid = get_typrelid(type(CString(CAR(yypvt[-0]))));
		    if (typrelid != InvalidObjectId) {
			elog(NOTICE, "cannot create attribute of type %s",
				     CString(CAR(yypvt[-0])));
			elog(WARN, "use functions to get complex objects");
		    }

		    yyval = MakeList(yypvt[-2],yypvt[-0],-1);
		} break;
case 279:
# line 1723 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ INC_LIST ;  } break;
case 280:
# line 1724 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ ELEMENT ; } break;
case 282:
# line 1729 "/usr/local/src/postgres/src/backend/parser/gram.y"
{NULLTREE} break;
case 283:
# line 1732 "/usr/local/src/postgres/src/backend/parser/gram.y"
{NULLTREE; } break;
case 284:
# line 1734 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		if (CInteger(CAR(yypvt[-0])) != BOOLOID)
		    elog(WARN,
			 "where clause must return type bool, not %s",
			 tname(get_id_type(CInteger(CAR(yypvt[-0])))));
		yyval = CDR(yypvt[-0]);
	    } break;
case 285:
# line 1749 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		List temp;

		temp = HandleNestedDots(yypvt[-1]);
		if (yypvt[-0] == LispNil)
		    yyval = temp;
		else
		    yyval = make_array_ref(temp, CDR(yypvt[-0]), CAR(yypvt[-0]));
		Typecast_ok = false;
	   } break;
case 287:
# line 1761 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = make_op(lispString("-"), LispNil, yypvt[-0], 'l');
		  Typecast_ok = false; } break;
case 288:
# line 1764 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = make_op (lispString("+"), yypvt[-2], yypvt[-0], 'b' ) ;
		  Typecast_ok = false; } break;
case 289:
# line 1767 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = make_op (lispString("-"), yypvt[-2], yypvt[-0], 'b' ) ;
		  Typecast_ok = false; } break;
case 290:
# line 1770 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = make_op (lispString("/"), yypvt[-2], yypvt[-0], 'b' ) ;
		  Typecast_ok = false; } break;
case 291:
# line 1773 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = make_op (lispString("*"), yypvt[-2], yypvt[-0], 'b' ) ;
		  Typecast_ok = false; } break;
case 292:
# line 1776 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = make_op (lispString("<"), yypvt[-2], yypvt[-0], 'b' ) ;
		  Typecast_ok = false; } break;
case 293:
# line 1779 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = make_op (lispString(">"), yypvt[-2], yypvt[-0], 'b' ) ;
		  Typecast_ok = false; } break;
case 294:
# line 1782 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = make_op (lispString("="), yypvt[-2], yypvt[-0], 'b' ) ;
		  Typecast_ok = false; } break;
case 295:
# line 1785 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = make_op (lispString(":"), LispNil, yypvt[-0], 'l' ) ;
		Typecast_ok = false; } break;
case 296:
# line 1788 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = make_op (lispString(";"), LispNil, yypvt[-0], 'l' ) ;
		Typecast_ok = false; } break;
case 297:
# line 1791 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = make_op (lispString("|"), LispNil, yypvt[-0], 'l' ) ;
		Typecast_ok = false; } break;
case 298:
# line 1794 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ 
		    extern LispValue parser_typecast();
		    yyval = parser_typecast ( yypvt[-2], yypvt[-0] );
		    Typecast_ok = false; /* it's already typecasted */
					 /* don't do it again. */ } break;
case 299:
# line 1800 "/usr/local/src/postgres/src/backend/parser/gram.y"
{yyval = yypvt[-1];} break;
case 300:
# line 1802 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = make_op ( yypvt[-1], yypvt[-2] , yypvt[-0], 'b' );
		  Typecast_ok = false; } break;
case 301:
# line 1805 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = make_op ( yypvt[-1], LispNil, yypvt[-0], 'l');
		  Typecast_ok = false; } break;
case 302:
# line 1808 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = make_op ( yypvt[-0], yypvt[-1], LispNil, 'r');
		  Typecast_ok = false; } break;
case 303:
# line 1811 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispCons ( KW(relation), yypvt[-0] );
                  INC_NUM_LEVELS(1);
		  Typecast_ok = false; } break;
case 304:
# line 1815 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
			extern List ParseFunc();
			yyval = ParseFunc ( CString ( yypvt[-2] ), LispNil );
			Typecast_ok = false;
		} break;
case 305:
# line 1821 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
			extern List ParseFunc();
			yyval = ParseFunc ( CString ( yypvt[-3] ), yypvt[-1] );
			Typecast_ok = false; } break;
case 306:
# line 1826 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
				 extern List ParseFunc();
				 yyval =  nappend1( LispNil, yypvt[-1]);
				 yyval = ParseFunc( "NullValue", yyval );
				 Typecast_ok = false; } break;
case 307:
# line 1832 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
			extern List ParseFunc();
			 yyval =  nappend1( LispNil, yypvt[-1]);
			 yyval = ParseFunc( "NonNullValue", yyval );
			 Typecast_ok = false;
		} break;
case 308:
# line 1839 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		if (CInteger(CAR(yypvt[-2])) != BOOLOID)
		    elog(WARN,
			 "left-hand side of AND is type '%s', not bool",
			 tname(get_id_type(CInteger(CAR(yypvt[-2])))));
		if (CInteger(CAR(yypvt[-0])) != BOOLOID)
		    elog(WARN,
			 "right-hand side of AND is type '%s', not bool",
			 tname(get_id_type(CInteger(CAR(yypvt[-0])))));

		yyval = lispCons(lispInteger(BOOLOID),
			      MakeList (lispInteger(AND),
					CDR(yypvt[-2]), CDR(yypvt[-0]), -1));
	    } break;
case 309:
# line 1854 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		if (CInteger(CAR(yypvt[-2])) != BOOLOID)
		    elog(WARN,
			 "left-hand side of OR is type '%s', not bool",
			 tname(get_id_type(CInteger(CAR(yypvt[-2])))));
		if (CInteger(CAR(yypvt[-0])) != BOOLOID)
		    elog(WARN,
			 "right-hand side of OR is type '%s', not bool",
			 tname(get_id_type(CInteger(CAR(yypvt[-0])))));

		yyval = lispCons(lispInteger(BOOLOID),
			      MakeList (lispInteger(OR),
					CDR(yypvt[-2]), CDR(yypvt[-0]), -1));
	    } break;
case 310:
# line 1869 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		if (CInteger(CAR(yypvt[-0])) != BOOLOID)
		    elog(WARN,
			 "argument to NOT is type '%s', not bool",
			 tname(get_id_type(CInteger(CAR(yypvt[-0])))));

		yyval = lispCons(lispInteger(BOOLOID),
			      MakeList (lispInteger(NOT),
					CDR(yypvt[-0]), -1));
	    } break;
case 311:
# line 1884 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		if (CInteger(CAR(yypvt[-2])) != INT4OID)
		    elog(WARN, "array index expressions must be int4's");
		if (yypvt[-0] != LispNil)
			yyval = lispCons(LispNil, lispCons(CDR(yypvt[-2]), CDR(yypvt[-0])));
		else yyval = lispCons(LispNil, lispCons(CDR(yypvt[-2]), LispNil));
	    } break;
case 312:
# line 1892 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		if ((CInteger(CAR(yypvt[-4])) != INT4OID)||(CInteger(CAR(yypvt[-2])) != INT4OID))
		    elog(WARN, "array index expressions must be int4's");
		if (yypvt[-0] != LispNil)
		yyval = lispCons(lispCons(CDR(yypvt[-4]), CAR(yypvt[-0])), lispCons(CDR(yypvt[-2]), CDR(yypvt[-0])));
		else 
		yyval = lispCons(lispCons(CDR(yypvt[-4]), LispNil), lispCons(CDR(yypvt[-2]), LispNil));
	    } break;
case 313:
# line 1900 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ NULLTREE } break;
case 314:
# line 1903 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ ELEMENT ; } break;
case 315:
# line 1904 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ INC_LIST ; } break;
case 316:
# line 1908 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		    INC_NUM_LEVELS(1);
		    yyval = lispCons(yypvt[-2],yypvt[-0]);
		} break;
case 317:
# line 1914 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		INC_NUM_LEVELS(1);
		yyval = lispCons(yypvt[-2],yypvt[-0]);
	    } break;
case 318:
# line 1921 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispCons(yypvt[-0], LispNil); } break;
case 319:
# line 1922 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = nappend1(yypvt[-2], yypvt[-0]);} break;
case 320:
# line 1926 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
	       LispValue varnode, temp;
	       Resdom resnode;
	       int type_id, type_len;

	       temp = HandleNestedDots(yypvt[-0]);

	        type_id = CInteger(CAR(temp));

		if (ISCOMPLEX(type_id))
		    elog(WARN,
			 "Cannot use complex type %s as atomic value in target list",
			 tname(get_id_type(type_id)));

	        type_len = tlen(get_id_type(type_id));
	        resnode = MakeResdom ( (AttributeNumber)1,
				     (ObjectId)type_id, ISCOMPLEX(type_id),
				     (Size)type_len,
				     (Name)CString(CAR(last (yypvt[-0]) )),
				     (Index)0 , (OperatorTupleForm)0 ,
				     0 );
	        varnode = CDR(temp);

	        yyval = lispCons((LispValue)resnode, lispCons(varnode,LispNil));
	 } break;
case 321:
# line 1954 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		 LispValue query2;
		 LispValue varnode = yypvt[-2];
		 yypvt[-2] = lispCons(yypvt[-2], LispNil);
		 query2 = MakeRoot(1, KW(retrieve), LispNil,
		 p_rtable, p_priority, p_ruleinfo, LispNil,
		 LispNil,yypvt[-2]);
		
		 query2 = lispCons (query2, LispNil);
		 query2 = nappend1 (query2, yypvt[-2]);
		 query2 = nappend1 (query2, yypvt[-1]);
		 /* query2 now retrieves the subquery within the
		  * agg brackets.
		  * this will be the agg node's outer child.
		  */

		  yyval = ParseAgg(CString(yypvt[-4]), query2, varnode);

		  /*paramlist = search_quals($4, aggnode);*/
		  /*$$ = nappend1($$, $4);*/
		  /* (rettype, "agg",aggname, query, tlist, -1) */
	} break;
case 322:
# line 1979 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ p_target = nappend1(p_target,yypvt[-0]); yyval = p_target; } break;
case 323:
# line 1981 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ p_target = lispCons (yypvt[-0],LispNil); yyval = p_target;} break;
case 324:
# line 1983 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
			LispValue temp = p_target;
			INC_NUM_LEVELS(1);
			if(temp == LispNil )
			  p_target = ExpandAll((Name)CString(yypvt[-2]), &p_last_resno);
			else {
			  while (temp != LispNil && CDR(temp) != LispNil)
			    temp = CDR(temp);
			  CDR(temp) = ExpandAll( (Name)CString(yypvt[-2]), &p_last_resno);
			}
			yyval = p_target;
		} break;
case 325:
# line 1996 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
			LispValue temp = p_target;
			if (ResdomNoIsAttrNo == true) {
			  elog(WARN,"all doesn't make any sense here");
			  return(1);
			}
			INC_NUM_LEVELS(1);
			if(temp == LispNil )
			  p_target = ExpandAll((Name)CString(yypvt[-2]), &p_last_resno);
			else {
			  while(temp != LispNil && CDR(temp) != LispNil )
			    temp = CDR(temp);
			  CDR(temp) = ExpandAll( (Name)CString(yypvt[-2]), &p_last_resno);
			}
			yyval = p_target;
		} break;
case 326:
# line 2016 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
	     int type_id;
	     int resdomno,  type_len;
	     List temp = LispNil;

	     type_id = CInteger(CAR(yypvt[-0]));

	     if (ISCOMPLEX(type_id))
		elog(WARN,
		   "Cannot assign complex type to variable %s in target list",
		   CString(yypvt[-3]));

	     type_len = tlen(get_id_type(type_id));
	     resdomno = p_last_resno++;
	     temp = lispCons ((LispValue)MakeResdom((AttributeNumber)resdomno,
					 (ObjectId)type_id,
					 ISCOMPLEX(type_id),
					 (Size)type_len,
					 (Name)CString(yypvt[-3]),
					 (Index)0, (OperatorTupleForm)0, 0) 
			      , lispCons(CDR(yypvt[-0]), LispNil) );
		yyval = temp;
	} break;
case 327:
# line 2041 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		if (yypvt[-0] != LispNil && ISCOMPLEX(CInteger(CAR(yypvt[-0]))))
		    elog(WARN, "Cannot assign complex type to variable %s in target list", CString(yypvt[-3]));
		if ((parser_current_query == APPEND) && (yypvt[-2] != LispNil)) {
			char * val;
			char *str, *save_str;
			LispValue elt;
			int i = 0, ndims, j = 0;
			int lindx[MAXDIM], uindx[MAXDIM];
    		int resdomno;
    		Relation rd;

            val = (char *) textout((struct varlena *)
							get_constvalue((Const)CDR(yypvt[-0])));
			str = save_str = palloc(strlen(val) + MAXDIM*25);
			foreach(elt, CDR(yypvt[-2])) {
				if (!IsA(CAR(elt),Const)) 
					elog(WARN, "Array Index for Append should be a constant");
				uindx[i++] = get_constvalue((Const)CAR(elt));
			}
			if (CAR(yypvt[-2]) != LispNil) {
				foreach(elt, CAR(yypvt[-2])) {
				if (!IsA(CAR(elt),Const)) 
					elog(WARN, "Array Index for Append should be a constant");
				lindx[j++] = get_constvalue((Const)CAR(elt));
				}
				if (i != j) elog(WARN, "yyparse: dimension mismatch");
			} else for (j = 0; j < i; lindx[j++] = 1);
			for (j = 0; j < i; j++) {
				if (lindx[j] > uindx[j]) 
				  elog(WARN, "yyparse: lower index cannot be greater than upper index");
				sprintf(str, "[%d:%d]", lindx[j], uindx[j]);
				str += strlen(str);
			}
			sprintf(str, "=%s", val);
			rd = parser_current_rel;
			Assert(rd != NULL);
			resdomno = varattno(rd,CString(yypvt[-3]));
			ndims = att_attnelems(rd,resdomno);
			if (i != ndims) elog(WARN, "yyparse: array dimensions do not match");
			yyval = make_targetlist_expr (yypvt[-3], make_const(lispString(save_str)), LispNil);
			pfree(save_str);
		}
		else
		yyval = make_targetlist_expr (yypvt[-3],yypvt[-0], yypvt[-2]);
	   } break;
case 328:
# line 2088 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		 LispValue varnode, temp;
		 Resdom resnode;
		 int type_id, type_len;

		 temp = HandleNestedDots(yypvt[-1]);

		 if (yypvt[-0] != LispNil)
		     temp = make_array_ref(temp, CDR(yypvt[-0]), CAR(yypvt[-0])); 

		 type_id = CInteger(CAR(temp));
		 if (ISCOMPLEX(type_id))
		     elog(WARN, "Cannot use complex type %s as atomic value in target list",
			  tname(get_id_type(type_id)));
		 type_len = tlen(get_id_type(type_id));
		 resnode = MakeResdom ( (AttributeNumber)p_last_resno++ ,
					(ObjectId)type_id, ISCOMPLEX(type_id),
				        (Size)type_len, 
					(Name)CString(CAR(last (yypvt[-1]) )),
					(Index)0 , (OperatorTupleForm)0,
					0 );
		 varnode = CDR(temp);
		 yyval=lispCons((LispValue)resnode, lispCons(varnode,LispNil));
	    } break;
case 329:
# line 2115 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ NULLTREE } break;
case 332:
# line 2122 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		/* disallow refs to magic system tables */
		if (strncmp(CString(yypvt[-0]), Name_pg_log, 16) == 0
		    || strncmp(CString(yypvt[-0]), Name_pg_variable, 16) == 0
		    || strncmp(CString(yypvt[-0]), Name_pg_time, 16) == 0
		    || strncmp(CString(yypvt[-0]), Name_pg_magic, 16) == 0)
		    elog(WARN, "%s cannot be accessed by users", CString(yypvt[-0]));
		else
		    yyval = yypvt[-0];
	  } break;
case 343:
# line 2145 "/usr/local/src/postgres/src/backend/parser/gram.y"
{yyval = new_filestr(yypvt[-0]); } break;
case 344:
# line 2147 "/usr/local/src/postgres/src/backend/parser/gram.y"
{yyval = new_filestr(yypvt[-0]); } break;
case 345:
# line 2148 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispString(CppAsString(stdin)); } break;
case 346:
# line 2149 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = lispString(CppAsString(stdout)); } break;
case 348:
# line 2154 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = make_const ( yypvt[-0] ) ; 
					  Input_is_integer = true; } break;
case 349:
# line 2156 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = make_const ( yypvt[-0] ) ; } break;
case 350:
# line 2157 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = make_const ( yypvt[-0] ) ; } break;
case 351:
# line 2158 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = make_const ( yypvt[-0] ) ; 
					  Input_is_string = true; } break;
case 352:
# line 2160 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
		yyval = lispCons(lispInteger(get_paramtype((Param)yypvt[-0])), yypvt[-0]);
	    } break;
case 353:
# line 2163 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = LispNil; 
					  Typecast_ok = false; } break;
case 354:
# line 2167 "/usr/local/src/postgres/src/backend/parser/gram.y"
{
	    ObjectId toid;
	    int paramno;
	    
	    paramno = CInteger(yypvt[-0]);
	    toid = param_type(paramno);
	    if (!ObjectIdIsValid(toid)) {
		elog(WARN, "Parameter '$%d' is out of range",
		     paramno);
	    }
	    yyval = (LispValue) MakeParam(PARAM_NUM, (AttributeNumber) paramno,
				       (Name)"<unnamed>", (ObjectId)toid,
				       (List) NULL);
	  } break;
case 356:
# line 2185 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = yylval; } break;
case 357:
# line 2188 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = yylval; } break;
case 358:
# line 2189 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = yylval; } break;
case 359:
# line 2192 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = yylval; } break;
case 360:
# line 2197 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ 
		    if (QueryIsRule)
		      yyval = lispString("*CURRENT*");
		    else 
		      elog(WARN,"\"current\" used in non-rule query");
		} break;
case 361:
# line 2204 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ 
		    if (QueryIsRule)
		      yyval = lispString("*NEW*");
		    else 
		      elog(WARN,"NEW used in non-rule query"); 
		    
		} break;
case 362:
# line 2213 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = yylval ; } break;
case 363:
# line 2214 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = yylval ; } break;
case 364:
# line 2215 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = yylval ; } break;
case 365:
# line 2216 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = yylval ; } break;
case 366:
# line 2217 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = yylval ; } break;
case 367:
# line 2218 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = yylval ; } break;
case 368:
# line 2219 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = yylval ; } break;
case 369:
# line 2220 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = yylval ; } break;
case 370:
# line 2221 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = yylval ; } break;
case 371:
# line 2222 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = yylval ; } break;
case 372:
# line 2223 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = yylval ; } break;
case 373:
# line 2224 "/usr/local/src/postgres/src/backend/parser/gram.y"
{ yyval = yylval ; } break; 
		}
		goto yystack;  /* stack new state and value */

	}
