c
c See the copyright notice (COPYRIGHT) in this directory.
c
c/*
c * NAME
c *	gdi_f77_defs.h
c *
c * SYNOPSIS
c *
c *	#include "libgendb.h"
c *
c *
c * DESCRIPTION
c *
c *      FORTRAN data structure
c *
c * DIAGNOSTICS
c *
c *
c * FILES
c *
c *
c * NOTES
c *
c *
c * SEE ALSO
c *
c *
c * AUTHOR
c *	H. Turner
c */

c       @(#)gdi_f77_defs.h	16.1 8/3/93	
c       Copyright (c) 1992-1993 Science Applications International Corporation


C      FUNCTIONS

      INTEGER GDI_ADD_MAP_FIELD
      INTEGER GDI_ABORT
      INTEGER GDI_CHANNEL_IS_OPEN
      INTEGER GDI_CLOSE
      INTEGER GDI_CLOSE_CHANNEL
C      INTEGER GDI_CLOSE_MAP
      INTEGER GDI_COMMIT
      INTEGER GDI_DEAD
      INTEGER GDI_ERROR_FLAGS
C      INTEGER GDI_ERROR_GET
C      INTEGER GDI_ERROR_INIT
      INTEGER GDI_EXIT
      INTEGER GDI_FLUSH
      INTEGER GDI_GET_ACCOUNT
      INTEGER GDI_GET_COUNTER
      INTEGER GDI_GET_DATABASE
c      INTEGER GDI_GET_NODE
      INTEGER GDI_INIT
      INTEGER GDI_OPEN
      INTEGER GDI_OPEN_CHANNEL
      INTEGER GDI_OPEN_MAP
      INTEGER GDI_PRINT_CONN
      INTEGER GDI_ROLLBACK
      INTEGER GDI_SAVEPOINT
      INTEGER GDI_SLEEP
      INTEGER GDI_SUBMIT

      EXTERNAL GDI_ADD_MAP_FIELD !$PRAGMA C (GDI_ADD_MAP_FIELD_)
      EXTERNAL GDI_ABORT !$PRAGMA C (GDI_ABORT_)
      EXTERNAL GDI_CHANNEL_IS_OPEN !$PRAGMA C (GDI_CHANNEL_IS_OPEN_)
      EXTERNAL GDI_CLOSE !$PRAGMA C (GDI_CLOSE_)
      EXTERNAL GDI_CLOSE_CHANNEL !$PRAGMA C (GDI_CLOSE_CHANNEL_)
      EXTERNAL GDI_CLOSE_MAP !$PRAGMA C (GDI_CLOSE_MAP_)
      EXTERNAL GDI_COMMIT !$PRAGMA C (GDI_COMMIT_)
      EXTERNAL GDI_DEAD !$PRAGMA C (GDI_DEAD_)
      EXTERNAL GDI_DESTROY_MAP !$PRAGMA C (GDI_DESTROY_MAP_)
      EXTERNAL GDI_ERROR_FLAGS !$PRAGMA C (GDI_ERROR_FLAGS_)
      EXTERNAL GDI_ERROR_GET !$PRAGMA C (GDI_ERROR_GET_)
      EXTERNAL GDI_ERROR_INIT !$PRAGMA C (GDI_ERROR_INIT_)
      EXTERNAL GDI_EXIT !$PRAGMA C (GDI_EXIT_)
      EXTERNAL GDI_FLUSH !$PRAGMA C (GDI_FLUSH_)
      EXTERNAL GDI_GET_ACCOUNT !$PRAGMA C (GDI_GET_ACCOUNT_)
      EXTERNAL GDI_GET_COUNTER !$PRAGMA C (GDI_GET_COUNTER_)
      EXTERNAL GDI_GET_DATABASE !$PRAGMA C (GDI_GET_DATABASE_)
      EXTERNAL GDI_GET_NODE !$PRAGMA C (GDI_GET_NODE_)
      EXTERNAL GDI_INIT !$PRAGMA C (GDI_INIT_)
      EXTERNAL GDI_OPEN !$PRAGMA C (GDI_OPEN_)
      EXTERNAL GDI_OPEN_CHANNEL !$PRAGMA C (GDI_OPEN_CHANNEL_)
      EXTERNAL GDI_OPEN_MAP !$PRAGMA C (GDI_OPEN_MAP_)
      EXTERNAL GDI_PRINT_CONN !$PRAGMA C (GDI_PRINT_CONN_)
      EXTERNAL GDI_ROLLBACK !$PRAGMA C (GDI_ROLLBACK_)
      EXTERNAL GDI_SAVEPOINT !$PRAGMA C (GDI_SAVEPOINT_)
      EXTERNAL GDI_SLEEP !$PRAGMA C (GDI_SLEEP_)
      EXTERNAL GDI_SUBMIT !$PRAGMA C (GDI_SUBMIT_)
      EXTERNAL GDI_TRACE !$PRAGMA C (GDI_TRACE_)


C      CONSTANTS

      INTEGER GDI_MAX_COLUMNS
      INTEGER GDI_MAX_NAME
      INTEGER GDI_MAX_TYPE
      INTEGER GDI_MAX_KEYNAME
      INTEGER GDI_ERROR_SIZE
      INTEGER GDI_ACCOUNT_SIZE
      INTEGER GDI_DBNAME_SIZE
      INTEGER GDI_TABLENAME_SIZE
      INTEGER GDI_NODE_SIZE


C      DBDEBUG
      INTEGER GDI_DEBUG_OFF
      INTEGER GDI_DEBUG_ON
      INTEGER GDI_DEBUG_VERBOSE

C      DBSTATUS   
      INTEGER GDI_SUCCESS
      INTEGER GDI_FAILURE

C      DBCTYPE 
      INTEGER GDI_UNDEFINED
      INTEGER GDI_INT2
      INTEGER GDI_REAL4	
      INTEGER GDI_STRING
      INTEGER GDI_REAL8	
      INTEGER GDI_CHAR
      INTEGER GDI_INT4

C      DBLANG 
      INTEGER GDI_SQL
      INTEGER GDI_POSTQUEL
	
C      DBFORMAT 
      INTEGER GDI_FIXED_SPACE
      INTEGER GDI_DELIMITED
	
C      Misc.
      INTEGER GDI_NOT_USED
      INTEGER GDI_NO_CHAN
      INTEGER GDI_DEFAULT_CHAN
      INTEGER GDI_SELECT_CHAN
      INTEGER GDI_UPDATE_CHAN
      INTEGER GDI_INSERT_CHAN
      INTEGER GDI_CREATE_CHAN
      INTEGER GDI_DROP_CHAN

C      DBCORERCE 
      INTEGER GDI_DEFAULT_COERCE
      INTEGER GDI_DOUBLE_COERCE
      INTEGER GDI_STRING_COERCE
      INTEGER GDI_DBL_STR_COERCE

C      DBERRLEV 
      INTEGER GDI_NOERROR
      INTEGER GDI_WARNING
      INTEGER GDI_FATAL

C      DBQUERY 
C      INTEGER GDI_ROWS_AFFECTED
C      INTEGER GDI_CMD_NUM
C      INTEGER GDI_MORE_ROWS
C      INTEGER GDI_STATUS
C     +     GDI_ROWS_AFFECTED, GDI_CMD_NUM, GDI_MORE_ROWS, GDI_STATUS,


      INTEGER GDI_NOMAP
      INTEGER GDI_NOCONN

      COMMON /GDICOMMON/ GDI_MAX_COLUMNS, GDI_MAX_NAME, GDI_MAX_TYPE,
     +     GDI_MAX_KEYNAME, GDI_ERROR_SIZE, GDI_ACCOUNT_SIZE,
     +     GDI_DBNAME_SIZE, GDI_TABLENAME_SIZE, GDI_NODE_SIZE,
     +     GDI_DEBUG_OFF, GDI_DEBUG_ON, GDI_DEBUG_VERBOSE,
     +     GDI_SUCCESS, GDI_FAILURE, GDI_UNDEFINED, GDI_INT2,
     +     GDI_REAL4, GDI_STRING, GDI_REAL8, GDI_CHAR, GDI_INT4, 
     +     GDI_SQL, GDI_POSTQUEL, GDI_FIXED_SPACE,
     +     GDI_DELIMITED, GDI_NOT_USED, GDI_NO_CHAN, GDI_DEFAULT_CHAN,
     +     GDI_SELECT_CHAN, GDI_UPDATE_CHAN, GDI_INSERT_CHAN,
     +     GDI_CREATE_CHAN, GDI_DROP_CHAN, GDI_DEFAULT_COERCE,
     +     GDI_DOUBLE_COERCE, GDI_STRING_COERCE, GDI_DBL_STR_COERCE,
     +     GDI_NOCONN, GDI_NOMAP, GDI_WARNING, GDI_FATAL, GDI_NOERROR
	


