/*
 *  Copyright 1992 Science Applications International Corporation.
 */

/*
 * NAME    
 *	gdi_turbo.h
 *
 * SYNOPSIS
 *      Contains defines and function prototypes for the Generic Database
 *	Interface support of the css style tuples.
 *
 * DESCRIPTION
 *
 *
 * DIAGNOSTICS
 *
 *
 * FILES
 *
 *
 * SEE ALSO
 *
 *
 * AUTHOR
 *	Mari Mortell	February 1993
 *
 *
 * MODIFICATIONS
 *
 */

/*
 *	SccsId:  @(#)gdi_turbo.h	16.1 8/3/93
 */

#ifndef _GDI_TURBO_H_
#define _GDI_TURBO_H_

#include "libgendb.h"

extern dbConstr GDI_TURBO;

typedef struct
{
     int        str_length;	/* only valid for strings      */
     int        arr_length;	/* only valid for arrays       */
     int        is_null;	/* does value hold a null?     */
     dbValue    value;		/* the data itself             */
} turboCol;

typedef struct
{
     dbColDef	**col_defs;	/* copy of the col_defs field in the dbObj */
     int        n_columns;	/* number of columns	       */
     turboCol   *col;           /* array of column data arrays */
} turboTup;


#endif
