/* See the copyright notice (COPYRIGHT) in this directory. */

/*
 * NAME
 *	f77_gdi_abort.c
 *
 * SYNOPSIS
 *
 *	#include "libgdi.h"
 *      #include <stddef.h>
 *      #include <stdlib.h>
 *      #include "utilities.h"
 *
 *
 * DESCRIPTION
 *
 *	This file contains the f77 interface to functions for the 
 *      database aborts.
 *
 * DIAGNOSTICS
 *
 *	Functions which return pointers will return NULL if an error
 *	occurred.  Functions which return a non-negative int will return 
 *	-1 if an error occurred.
 *
 * FILES
 *
 *	gdi_f77_abort.c (this file)
 *	gdi_abort.c 
 *
 * NOTES
 *
 *
 * SEE ALSO
 *
 *	libgdi.h
 *
 * AUTHOR
 *	H. Turner
 */


#include <stddef.h>
#include <stdlib.h>
#include "utilities.h"
#include "f77defs.h"
#include "libgdi.h"

#ifndef	lint
static char SccsId[] = "@(#)gdi_f77_abort.c	16.2 8/11/93 Copyright (c) 1992-1993 Science Applications International Corporation";
#endif

int 
gdi_abort_(conn)
int *conn;
{
	return (gdi_abort(get_db_conn(*conn)));
}

			  
