/* See the copyright notice (COPYRIGHT) in this directory. */

/*
 * NAME
 *	gdi_open_channel(), gdi_close_channel(), gdi_channel_is_open(),
 *	gdi_flush()
 *
 * DESCRIPTION
 *	This file contains the FORTRAN interface to functions 
 *      for managing database channels.
 *
 * DIAGNOSTICS
 *	Functions which return pointers will return NULL if an error
 *	occurred.  Functions which return a non-negative int will return 
 *	-1 if an error occurred.
 *
 * FILES
 *	gdi_f77_channel.c (this file)
 *	gdi_channel.c 
 *
 * AUTHOR
 *	H. Turner
 */


#include "libgdi.h"
#include "f77defs.h"

#ifndef	lint
static char SccsId[] = "@(#)gdi_f77_channel.c	16.2 8/11/93 Copyright (c) 1992-1993 Science Applications International Corporation";
#endif


int
gdi_open_channel_ (conn, channo)
int *conn;
int *channo;
{
	return (gdi_open_channel(get_db_conn(*conn),
				 channo));
}



/*
 * gdi_close_channel ()
 *
 * Close a database channel.
 *
 * Public
 */

int
gdi_close_channel_ (conn, channo)
int	*conn;
int	*channo;
{
	return (gdi_close_channel(get_db_conn(*conn),
				  *channo));
	
}





/*
 * gdi_channel_is_open ()
 *
 * Determine if a specified channel is open.  Return TRUE or FALSE.
 *
 * Public
 */

int
gdi_channel_is_open_ (conn, channo)
int	*conn;
int	*channo;
{
	return (gdi_channel_is_open(get_db_conn(*conn),
				    *channo));
}



/*
 * gdi_flush ()
 *
 * Flush a database channel.
 *
 * Public
 */

int
gdi_flush_ (conn, channo)
int	*conn;
int	*channo;
{
	return (gdi_flush(get_db_conn(*conn),
			  *channo));
}








