/* See the copyright notice (COPYRIGHT) in this directory. */

/*
 * NAME
 *	gdi_print_conn()
 *
 * SYNOPSIS
 *
 *	#include "libgdi.h"
 *
 *	int
 *	gdi_print_conn (conn)
 *	dbConn	*conn;
 *

 *
 * DESCRIPTION
 *
 *	This file contains function for printing the contents of a
 *	database connector (dbConn) to stdout.
 *
 * DIAGNOSTICS
 *
 *	Functions which return pointers will return NULL if an error
 *	occurred.  Functions which return a non-negative int will return 
 *	-1 if an error occurred.
 *
 * FILES
 *
 *	gdi_f77_print.c (this fil)e
 *	gdi_print.c 
 *
 * SEE ALSO
 *	gdi_print_conn(3), gdi_print_coldefs(3), gdi_print_dbobj(3),
 *	gdi_print_tuples(3)
 *
 * AUTHOR
 *	H. Turner
 */


#include "utilities.h"
#include "libgdi.h"
#include "f77defs.h"

#ifndef	lint
static char SccsId[] = "@(#)gdi_f77_print.c	16.2 8/11/93 Copyright (c) 1992-1993 Science Applications International Corporation";
#endif




/*
 * gdi_print_conn ()
 *
 * Print the contents of a database connection to stdout.
 *
 * Public
 */

int
gdi_print_conn_ (conn)
int	*conn;
{
	return (gdi_print_conn(get_db_conn(*conn)));
}


