/* See the copyright notice (COPYRIGHT) in this directory. */

/*
 * NAME
 *	gdi_sleep()
 *
 * SYNOPSIS
 *	#include "libgdi.h"
 *
 *	void
 *	gdi_sleep (conn, max_sleep)
 *	dbConn   *conn;		(i) Unix pid is stored here
 *	int  max_sleep;		(i) maximum number of seconds to sleep
 *
 * DESCRIPTION
 *	gdi_sleep() sleeps a random number of seconds that does not exceed
 *	max_sleep seconds. The sleep is random to de-synchronize the retries
 *	of processes pinging the same resource.
 *
 * FILES
 *	gdi_f77_sleep.c (this file)
 *	gdi_sleep.c
 *
 * SEE ALSO
 *	gdi_sleep(3)
 *
 * AUTHOR
 *	H. Turner
 */

#include "libgdi.h"
#include "f77defs.h"

#ifndef	lint
static char SccsId[] = "@(#)gdi_f77_sleep.c	16.2 8/11/93 Copyright (c) 1992-1993 Science Applications International Corporation";
#endif

void
gdi_sleep_(conn, max_sleep)
int  *conn;
int  *max_sleep;
{
	gdi_sleep(get_db_conn(*conn),
		  *max_sleep);
}
