/* See the copyright notice (COPYRIGHT) in this directory. */

/*
 * NAME
 *	pg_create.c
 *
 * SYNOPSIS
 *	#include "libgendb.h"
 *	#include "gdi_postgres.h"
 *
 * DESCRIPTION
 *
 *	This file contains functions for creating POSTGRES tables.
 *
 * DIAGNOSTICS
 *
 *	Functions which return pointers return NULL if an error
 *	occurs.  Functions which return a non-negative int return 
 *	-1 if an error occurs.
 *
 * FILES
 *	pg_create.c (this file)
 *
 * SEE ALSO
 *	libgendb.h
 *	gdi_postgres.h
 *
 * AUTHOR
 *	B. MacRitchie
 */

#ifndef	lint
static char SccsId[] = "@(#)pg_create.c	16.1 8/3/93 Copyright (c) 1992-1993 Science Applications International Corporation";
#endif

#include "gdi_postgres.h"

/*
 * pg_create_table ()
 *
 * Create an POSTGRES class.  If class name is of the form "#name", 
 * create a temporary table called "name_session_id".  Add temporary
 * table names to dbConn for later cleanup.  
 *
 * Create table syntax is:
 * 	"create table table_name (col1_name col1_type, col2_name col2_type, ...)
 *
 * Public
 */

dbStatus
pg_create_table (conn, table_name, table_def)
dbConn		*conn;
char		*table_name;
dbObj		*table_def;
{
	char *routine="pg_create_table";
	fprintf(stderr, "%16s: %s\n", routine, PG_NOT_IMPLEMENTED);
	return (GDI_SUCCESS);
}
