/* See the copyright notice (COPYRIGHT) in this directory. */

/*
 * NAME
 *	pg_insert.c
 *
 * SYNOPSIS
 *
 *	#include "libgendb.h"
 *	#include "gdi_postgres.h"
 *
 *	dbStatus
 *	pg_insert(dbconn, table, inobj)
 * 	dbConn	*dbconn;	(I) connection returned by gdi_open
 *	char	*table;		(I) The table to insert into
 *	dbObj	*inobj;		(I) the dbObj holding column defs and data.

 *
 * DESCRIPTION
 * 	Insert data into a POSTGRES class.
 *
 * Public
 *	This file contains functions for inserting data into POSTGRES tables.
 *
 *	GDI_OBJ_ROWS_AFFECTED(dbobj) contains the number of rows  inserted.
 *
 * DIAGNOSTICS
 *
 *	Functions which return pointers will return NULL if an error
 *	occurred.  Functions which return a non-negative int will return 
 *	-1 if an error occurred.
 *
 * FILES
 *	gdi_insert.c (called by)
 *
 * SEE ALSO
 *	libgendb.h
 *	db_postgres.h
 */


#ifndef	lint
static char SccsId[] = "@(#)pg_insert.c	16.1 8/3/93 Copyright (c) 1992-1993 Science Applications International Corporation";
#endif

#include "gdi_postgres.h"		/* generic db interface header */

dbStatus
pg_insert(dbconn, table, inobj)
dbConn	*dbconn;
char	*table;
dbObj	*inobj;
{
	
	fprintf(stderr, "pg_insert: %s\n", PG_NOT_IMPLEMENTED);
	return(GDI_SUCCESS);
}

