/* See the copyright notice (COPYRIGHT) in this directory. */

/*
 * NAME
 *	pg_temp_name()
 *	pg_add_table()
 *	pg_drop_tables()
 *
 * SYNOPSIS
 *	#include "libgendb.h"
 *	#include "gdi_postgres.h"
 *
 * DESCRIPTION
 *	This file contains functions for POSTGRES temp tables.
 *
 * DIAGNOSTICS
 *	Functions which return pointers will return NULL if an error
 *	occurred.  Functions which return a non-negative int will return 
 *	-1 if an error occurred.
 *
 * FILES
 *	pg_temp.c (this file)
 *
 * SEE ALSO
 *	libgendb.h
 *	gdi_postgres.h
 *
 * AUTHOR
 *	B. MacRitchie
 */

#ifndef	lint
static char SccsId[] = "@(#)pg_temp.c	16.2 8/7/93 Copyright (c) 1992-1993 Science Applications International Corporation";
#endif

#include "gdi_postgres.h"

/* pg_temp_name ()
 *
 * Determine actual table name.  If table name begins with '#', create
 * a new name with the POSTGRES session id.
 *
 * Public
 */

dbStatus
pg_temp_name (conn, name, new_name)
dbConn	*conn;
char	*name;
char	*new_name;
{
	char	*routine="pg_temp_name: ";
	fprintf(stderr, "%s %s\n", routine, PG_NOT_IMPLEMENTED);
	return (GDI_SUCCESS);
}



/*
 * pg_add_table ()
 *
 * Add table name to conn for bookeeping.
 *
 * Public
 */

dbStatus
pg_add_table (conn, name)
dbConn	*conn;
char	*name;
{
	char *routine="pg_add_table: ";
	fprintf(stderr, "%s %s\n", routine, PG_NOT_IMPLEMENTED);
	return (GDI_SUCCESS);
}



/*
 * pg_drop_tables ()
 *
 * Drop tables in temporary table list
 *
 * Public
 */

dbStatus
pg_drop_tables (conn)
dbConn	*conn;
{
	char *routine="pg_add_table: ";
	fprintf(stderr, "%s %s\n", routine, PG_NOT_IMPLEMENTED);
	return (GDI_SUCCESS);
}
