#!/local/bin/wish -f
###############################################
###############################################
set auto_path "$tk_library/demos $auto_path"
set PGB(Home)   /usr/local/pgbrowse
# setup some paths
source "$PGB(Home)/lib/tkutils.tcl"
source "$PGB(Home)/lib/FD.tcl"
source "$PGB(Home)/lib/infobars.tcl"
mkMenuBar .menu {
	{ {version} {version -1.0 Pre alpha beta} }
} {
File {
	{{Execute icopy} {do_icopy} {Run  the icopy command with given
parameters}}
	{{Quit icopy tool} {quit_it} {Quits icopy tool } }
	}
}  

frame .in_out -bd 2 -rel raised 
pack append .in_out \
[radiobutton .in_out.in -text "To Postgres" -var in_or_out -value "in" \
-rel flat ] {left pady 0 frame w } \
[radiobutton .in_out.out -text "From Postgres" -var in_or_out -value "out" \
-rel flat ]  {left pady 0 frame w }

frame .storage -bd 1 -rel flat
pack append .storage \
[radiobutton .storage.sony_worm -text "Sony worm" -var storage_manager \
-rel flat -value "s" ] {left pady 0 frame w } \
[radiobutton .storage.hard_disk -text "Magnetic disk" -var storage_manager \
-rel flat -value "d" ] {left pady 0 frame w } 

# icopy {in|out} [-h host] [-p port] -d db -s smgr [-R] [-v] [-a] from to
frame .extras
pack append .extras \
[checkbutton .extras.verbose -rel flat -text "Verbose" -var verbose ] \
{left pady 4 } \
[checkbutton .extras.recursive -rel flat -text "Select Directory and Copy
Recursively" -var recursive] \
{left pady 4 expand } \
[checkbutton .extras.all_files -rel flat -text "All files (including .files)" \
	-var all_files  ] { left pady 4  }

foreach i {f1 f2 f3 } {
        frame .$i -bd 1m
        entry .$i.entry -relief sunken -width 40
        bind .$i.entry <Tab> "Tab \$tabList"
        label .$i.label
        pack append .$i .$i.entry right .$i.label right
}
    .f1.label config -text "Postgres Server"
    .f2.label config -text "Database"
    .f3.label config -text "Port"

    set tabList ".f1.entry .f2.entry .f3.entry"

#pack append .f1.entry insert end "heel.s2k.berkeley.edu" 
#pack append .f2.entry insert end "sequoia" 

frame .unix
radiobutton .unix.jims -text "File Finder" -var unix_file_method -val "jims" \
	-command read_unix_file -rel flat
radiobutton .unix.type_in -text "type in Unix File name" -var \
unix_file_method -val "type" -rel flat
entry .unix.ent -width 80 -relief sunken 
pack append .unix \
	.unix.jims left \
	.unix.type_in left \
	.unix.ent right

frame .description
label .description.lab -text "Enter Description of Data(for log entry)"
entry .description.ent -width 80 -relief sunken 
pack append .description \
.description.lab left \
.description.ent right
frame .large_obj
radiobutton .large_obj.jims -text "Large Object Finder" -var large_obj_method -val \
	"jims"  -command read_large_obj_file -rel flat
radiobutton .large_obj.type_in -text "type in Large Object File name" -var \
large_obj_method -val "type" -rel flat
entry .large_obj.ent -width 80 -relief sunken 
pack append .large_obj \
	.large_obj.jims left \
	.large_obj.type_in left \
	.large_obj.ent right



pack append .  .menu {top fill} \
.in_out {top pady 10} \
.storage {top pady 20} \
.f1 {top fillx} .f2 {top fillx} .f3 {top fillx} \
.extras {top pady 4 fillx } \
.unix {top fillx} \
.large_obj {top fillx} \
.description {top fillx pady 10} 

set storage_manager "d"
set in_or_out "in"
set large_obj_method "type"
set unix_file_method "type"
if [info exists env(PGHOST)] {
	.f1.entry insert 0 $env(PGHOST)
} else {
	.f1.entry insert 0 heel.cs.berekely.edu
}
if [info exists env(DATABASE)] {
	.f2.entry insert 0 $env(DATABASE)
} else {
	.f2.entry insert 0 sequoia
}
if [info exists env(PGPORT)] {
	.f3.entry insert 0 $env(PGPORT)
} else {
	.f3.entry insert 0 4321
}

proc quit_it {} {
	rm -rf pG_temp
	destroy . 
	}

proc do_icopy {} {

	global storage_manager in_or_out large_obj_method unix_file_method \
		file_from file_to all_files recursive verbose

	if {($in_or_out=="in")} {
			set file_to [.large_obj.ent get]
			set file_from [.unix.ent get]
	} else {
			set file_from [.large_obj.ent get]
			set file_to [.unix.ent get]
	}
	set host [.f1.entry get]
	set db [.f2.entry get]
	set port [.f3.entry get]
	set command "icopy $in_or_out"
	if {($db!="")} {
		set command "$command -d $db "
	} else {
		set command "$command -d sequoia "
		set db sequoia
	}
	if {($host!="")} {
		set command "$command -h $host "
	} else {
		set command "$command -h heel.cs.berkeley.edu "
		set host heel.cs.berkeley.edu
	}
	if {($port!="")} {
		set command "$command -p $port "
	} else {
		set command "$command -p 4321 "
		set port 4321
	}
	if {($recursive)} {
		set command "$command -R "
	} 
	if {($all_files)} {
		set command "$command -a "
	} 
	if {($verbose)} {
		set command "$command -v "
	} 
		set command  "$command -s $storage_manager $file_from $file_to"

	puts stdout $command
	#sh -c "$command"
	if {($in_or_out=="in")} {
		do_postgres_add $file_from $file_to $host $db $port
	}
}

proc do_postgres_add {unix_file large_obj host db port} {
	global storage_manager 
	set user [whoami]@[hostname]
	set date [date]
	set query "append icopy_info ( large_obj_name=\"$large_obj\""
	set query "$query, unix_file_name=\"$unix_file\""
	set query "$query, user_name=\"$user\""
	set query "$query, description=\"[.description.ent get]\""
	set query "$query, storage_manager=\"$storage_manager\""
	set query "$query, date=\"$date\")"
#	set query "monitor -N -T -Q -h $host -p $port -c \{ $query \} $db"
	monitor -N -T -Q -h $host -p $port -c  $query  $db
#	puts stdout $query
#	$query


}
proc read_large_obj_file {} {
	global .large_obj .unix recursive unix.jims  
	set host [.f1.entry get]
	set db [.f2.entry get]
	set port [.f3.entry get]
# if recursive bit is set, then call with -setdir 
# create directory hierarchy template:
# should pass in host and db ???
	exec lo_create.tcl
if {($recursive)}  {
	set lo_file [FDOpenFilename -dir pG_temp -setdir -title "UNIX directory to icopy to postgres"]
} else {
	set lo_file [FDOpenFilename  -dir pG_temp -title "UNIX file to icopy to postgres"]
}
	set new_file [ string range $lo_file [expr 7+[string first \
		"pG_temp" $lo_file ]] end]
	.large_obj.ent insert 0 $new_file
}

proc read_unix_file {} {
	global .unix recursive unix.jims
# if recursive bit is set, then call with -setdir 
if {($recursive)}  {
	set unix_file [FDOpenFilename -setdir -title "UNIX directory to icopy to postgres"]
	.unix.ent insert 0 $unix_file
} else {
	set unix_file [FDOpenFilename  -title "UNIX file to icopy to postgres"]
	.unix.ent insert 0 $unix_file
}
}


